/* AudioObject.c generated by valac 0.56.14, the Vala compiler
 * generated from AudioObject.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2021 elementary, Inc. (https://elementary.io)
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_AUDIO_OBJECT (music_audio_object_get_type ())
#define MUSIC_AUDIO_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject))
#define MUSIC_AUDIO_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObjectClass))
#define MUSIC_IS_AUDIO_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_AUDIO_OBJECT))
#define MUSIC_IS_AUDIO_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_AUDIO_OBJECT))
#define MUSIC_AUDIO_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObjectClass))

typedef struct _MusicAudioObject MusicAudioObject;
typedef struct _MusicAudioObjectClass MusicAudioObjectClass;
typedef struct _MusicAudioObjectPrivate MusicAudioObjectPrivate;
enum  {
	MUSIC_AUDIO_OBJECT_0_PROPERTY,
	MUSIC_AUDIO_OBJECT_URI_PROPERTY,
	MUSIC_AUDIO_OBJECT_TEXTURE_PROPERTY,
	MUSIC_AUDIO_OBJECT_ARTIST_PROPERTY,
	MUSIC_AUDIO_OBJECT_TITLE_PROPERTY,
	MUSIC_AUDIO_OBJECT_DURATION_PROPERTY,
	MUSIC_AUDIO_OBJECT_NUM_PROPERTIES
};
static GParamSpec* music_audio_object_properties[MUSIC_AUDIO_OBJECT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicAudioObject {
	GObject parent_instance;
	MusicAudioObjectPrivate * priv;
};

struct _MusicAudioObjectClass {
	GObjectClass parent_class;
};

struct _MusicAudioObjectPrivate {
	gchar* _uri;
	GdkTexture* _texture;
	gchar* _artist;
	gchar* _title;
	gint64 _duration;
};

static gint MusicAudioObject_private_offset;
static gpointer music_audio_object_parent_class = NULL;

VALA_EXTERN GType music_audio_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicAudioObject, g_object_unref)
VALA_EXTERN MusicAudioObject* music_audio_object_new (const gchar* uri);
VALA_EXTERN MusicAudioObject* music_audio_object_construct (GType object_type,
                                                const gchar* uri);
VALA_EXTERN const gchar* music_audio_object_get_uri (MusicAudioObject* self);
static void music_audio_object_set_uri (MusicAudioObject* self,
                                 const gchar* value);
VALA_EXTERN GdkTexture* music_audio_object_get_texture (MusicAudioObject* self);
VALA_EXTERN void music_audio_object_set_texture (MusicAudioObject* self,
                                     GdkTexture* value);
VALA_EXTERN const gchar* music_audio_object_get_artist (MusicAudioObject* self);
VALA_EXTERN void music_audio_object_set_artist (MusicAudioObject* self,
                                    const gchar* value);
VALA_EXTERN const gchar* music_audio_object_get_title (MusicAudioObject* self);
VALA_EXTERN void music_audio_object_set_title (MusicAudioObject* self,
                                   const gchar* value);
VALA_EXTERN gint64 music_audio_object_get_duration (MusicAudioObject* self);
VALA_EXTERN void music_audio_object_set_duration (MusicAudioObject* self,
                                      gint64 value);
static void music_audio_object_finalize (GObject * obj);
static GType music_audio_object_get_type_once (void);
static void _vala_music_audio_object_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_music_audio_object_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
music_audio_object_get_instance_private (MusicAudioObject* self)
{
	return G_STRUCT_MEMBER_P (self, MusicAudioObject_private_offset);
}

MusicAudioObject*
music_audio_object_construct (GType object_type,
                              const gchar* uri)
{
	MusicAudioObject * self = NULL;
#line 13 "../src/AudioObject.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 14 "../src/AudioObject.vala"
	self = (MusicAudioObject*) g_object_new (object_type, "uri", uri, NULL);
#line 13 "../src/AudioObject.vala"
	return self;
#line 123 "AudioObject.c"
}

MusicAudioObject*
music_audio_object_new (const gchar* uri)
{
#line 13 "../src/AudioObject.vala"
	return music_audio_object_construct (MUSIC_TYPE_AUDIO_OBJECT, uri);
#line 131 "AudioObject.c"
}

const gchar*
music_audio_object_get_uri (MusicAudioObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 7 "../src/AudioObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "../src/AudioObject.vala"
	_tmp0_ = self->priv->_uri;
#line 7 "../src/AudioObject.vala"
	result = _tmp0_;
#line 7 "../src/AudioObject.vala"
	return result;
#line 147 "AudioObject.c"
}

static void
music_audio_object_set_uri (MusicAudioObject* self,
                            const gchar* value)
{
	gchar* old_value;
#line 7 "../src/AudioObject.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/AudioObject.vala"
	old_value = music_audio_object_get_uri (self);
#line 7 "../src/AudioObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 161 "AudioObject.c"
		gchar* _tmp0_;
#line 7 "../src/AudioObject.vala"
		_tmp0_ = g_strdup (value);
#line 7 "../src/AudioObject.vala"
		_g_free0 (self->priv->_uri);
#line 7 "../src/AudioObject.vala"
		self->priv->_uri = _tmp0_;
#line 7 "../src/AudioObject.vala"
		g_object_notify_by_pspec ((GObject *) self, music_audio_object_properties[MUSIC_AUDIO_OBJECT_URI_PROPERTY]);
#line 171 "AudioObject.c"
	}
}

GdkTexture*
music_audio_object_get_texture (MusicAudioObject* self)
{
	GdkTexture* result;
	GdkTexture* _tmp0_;
#line 8 "../src/AudioObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "../src/AudioObject.vala"
	_tmp0_ = self->priv->_texture;
#line 8 "../src/AudioObject.vala"
	result = _tmp0_;
#line 8 "../src/AudioObject.vala"
	return result;
#line 188 "AudioObject.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 8 "../src/AudioObject.vala"
	return self ? g_object_ref (self) : NULL;
#line 196 "AudioObject.c"
}

void
music_audio_object_set_texture (MusicAudioObject* self,
                                GdkTexture* value)
{
	GdkTexture* old_value;
#line 8 "../src/AudioObject.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/AudioObject.vala"
	old_value = music_audio_object_get_texture (self);
#line 8 "../src/AudioObject.vala"
	if (old_value != value) {
#line 210 "AudioObject.c"
		GdkTexture* _tmp0_;
#line 8 "../src/AudioObject.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 8 "../src/AudioObject.vala"
		_g_object_unref0 (self->priv->_texture);
#line 8 "../src/AudioObject.vala"
		self->priv->_texture = _tmp0_;
#line 8 "../src/AudioObject.vala"
		g_object_notify_by_pspec ((GObject *) self, music_audio_object_properties[MUSIC_AUDIO_OBJECT_TEXTURE_PROPERTY]);
#line 220 "AudioObject.c"
	}
}

const gchar*
music_audio_object_get_artist (MusicAudioObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 9 "../src/AudioObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/AudioObject.vala"
	_tmp0_ = self->priv->_artist;
#line 9 "../src/AudioObject.vala"
	result = _tmp0_;
#line 9 "../src/AudioObject.vala"
	return result;
#line 237 "AudioObject.c"
}

void
music_audio_object_set_artist (MusicAudioObject* self,
                               const gchar* value)
{
	gchar* old_value;
#line 9 "../src/AudioObject.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/AudioObject.vala"
	old_value = music_audio_object_get_artist (self);
#line 9 "../src/AudioObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 251 "AudioObject.c"
		gchar* _tmp0_;
#line 9 "../src/AudioObject.vala"
		_tmp0_ = g_strdup (value);
#line 9 "../src/AudioObject.vala"
		_g_free0 (self->priv->_artist);
#line 9 "../src/AudioObject.vala"
		self->priv->_artist = _tmp0_;
#line 9 "../src/AudioObject.vala"
		g_object_notify_by_pspec ((GObject *) self, music_audio_object_properties[MUSIC_AUDIO_OBJECT_ARTIST_PROPERTY]);
#line 261 "AudioObject.c"
	}
}

const gchar*
music_audio_object_get_title (MusicAudioObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 10 "../src/AudioObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/AudioObject.vala"
	_tmp0_ = self->priv->_title;
#line 10 "../src/AudioObject.vala"
	result = _tmp0_;
#line 10 "../src/AudioObject.vala"
	return result;
#line 278 "AudioObject.c"
}

void
music_audio_object_set_title (MusicAudioObject* self,
                              const gchar* value)
{
	gchar* old_value;
#line 10 "../src/AudioObject.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/AudioObject.vala"
	old_value = music_audio_object_get_title (self);
#line 10 "../src/AudioObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 292 "AudioObject.c"
		gchar* _tmp0_;
#line 10 "../src/AudioObject.vala"
		_tmp0_ = g_strdup (value);
#line 10 "../src/AudioObject.vala"
		_g_free0 (self->priv->_title);
#line 10 "../src/AudioObject.vala"
		self->priv->_title = _tmp0_;
#line 10 "../src/AudioObject.vala"
		g_object_notify_by_pspec ((GObject *) self, music_audio_object_properties[MUSIC_AUDIO_OBJECT_TITLE_PROPERTY]);
#line 302 "AudioObject.c"
	}
}

gint64
music_audio_object_get_duration (MusicAudioObject* self)
{
	gint64 result;
#line 11 "../src/AudioObject.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 11 "../src/AudioObject.vala"
	result = self->priv->_duration;
#line 11 "../src/AudioObject.vala"
	return result;
#line 316 "AudioObject.c"
}

void
music_audio_object_set_duration (MusicAudioObject* self,
                                 gint64 value)
{
	gint64 old_value;
#line 11 "../src/AudioObject.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/AudioObject.vala"
	old_value = music_audio_object_get_duration (self);
#line 11 "../src/AudioObject.vala"
	if (old_value != value) {
#line 11 "../src/AudioObject.vala"
		self->priv->_duration = value;
#line 11 "../src/AudioObject.vala"
		g_object_notify_by_pspec ((GObject *) self, music_audio_object_properties[MUSIC_AUDIO_OBJECT_DURATION_PROPERTY]);
#line 334 "AudioObject.c"
	}
}

static void
music_audio_object_class_init (MusicAudioObjectClass * klass,
                               gpointer klass_data)
{
#line 6 "../src/AudioObject.vala"
	music_audio_object_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/AudioObject.vala"
	g_type_class_adjust_private_offset (klass, &MusicAudioObject_private_offset);
#line 6 "../src/AudioObject.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_audio_object_get_property;
#line 6 "../src/AudioObject.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_audio_object_set_property;
#line 6 "../src/AudioObject.vala"
	G_OBJECT_CLASS (klass)->finalize = music_audio_object_finalize;
#line 6 "../src/AudioObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_AUDIO_OBJECT_URI_PROPERTY, music_audio_object_properties[MUSIC_AUDIO_OBJECT_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/AudioObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_AUDIO_OBJECT_TEXTURE_PROPERTY, music_audio_object_properties[MUSIC_AUDIO_OBJECT_TEXTURE_PROPERTY] = g_param_spec_object ("texture", "texture", "texture", gdk_texture_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6 "../src/AudioObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_AUDIO_OBJECT_ARTIST_PROPERTY, music_audio_object_properties[MUSIC_AUDIO_OBJECT_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6 "../src/AudioObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_AUDIO_OBJECT_TITLE_PROPERTY, music_audio_object_properties[MUSIC_AUDIO_OBJECT_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6 "../src/AudioObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_AUDIO_OBJECT_DURATION_PROPERTY, music_audio_object_properties[MUSIC_AUDIO_OBJECT_DURATION_PROPERTY] = g_param_spec_int64 ("duration", "duration", "duration", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 362 "AudioObject.c"
}

static void
music_audio_object_instance_init (MusicAudioObject * self,
                                  gpointer klass)
{
#line 6 "../src/AudioObject.vala"
	self->priv = music_audio_object_get_instance_private (self);
#line 11 "../src/AudioObject.vala"
	self->priv->_duration = (gint64) 0;
#line 373 "AudioObject.c"
}

static void
music_audio_object_finalize (GObject * obj)
{
	MusicAudioObject * self;
#line 6 "../src/AudioObject.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 7 "../src/AudioObject.vala"
	_g_free0 (self->priv->_uri);
#line 8 "../src/AudioObject.vala"
	_g_object_unref0 (self->priv->_texture);
#line 9 "../src/AudioObject.vala"
	_g_free0 (self->priv->_artist);
#line 10 "../src/AudioObject.vala"
	_g_free0 (self->priv->_title);
#line 6 "../src/AudioObject.vala"
	G_OBJECT_CLASS (music_audio_object_parent_class)->finalize (obj);
#line 392 "AudioObject.c"
}

static GType
music_audio_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicAudioObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_audio_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicAudioObject), 0, (GInstanceInitFunc) music_audio_object_instance_init, NULL };
	GType music_audio_object_type_id;
	music_audio_object_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicAudioObject", &g_define_type_info, 0);
	MusicAudioObject_private_offset = g_type_add_instance_private (music_audio_object_type_id, sizeof (MusicAudioObjectPrivate));
	return music_audio_object_type_id;
}

GType
music_audio_object_get_type (void)
{
	static volatile gsize music_audio_object_type_id__once = 0;
	if (g_once_init_enter (&music_audio_object_type_id__once)) {
		GType music_audio_object_type_id;
		music_audio_object_type_id = music_audio_object_get_type_once ();
		g_once_init_leave (&music_audio_object_type_id__once, music_audio_object_type_id);
	}
	return music_audio_object_type_id__once;
}

static void
_vala_music_audio_object_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MusicAudioObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 6 "../src/AudioObject.vala"
	switch (property_id) {
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_URI_PROPERTY:
#line 6 "../src/AudioObject.vala"
		g_value_set_string (value, music_audio_object_get_uri (self));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_TEXTURE_PROPERTY:
#line 6 "../src/AudioObject.vala"
		g_value_set_object (value, music_audio_object_get_texture (self));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_ARTIST_PROPERTY:
#line 6 "../src/AudioObject.vala"
		g_value_set_string (value, music_audio_object_get_artist (self));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_TITLE_PROPERTY:
#line 6 "../src/AudioObject.vala"
		g_value_set_string (value, music_audio_object_get_title (self));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_DURATION_PROPERTY:
#line 6 "../src/AudioObject.vala"
		g_value_set_int64 (value, music_audio_object_get_duration (self));
#line 6 "../src/AudioObject.vala"
		break;
#line 457 "AudioObject.c"
		default:
#line 6 "../src/AudioObject.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/AudioObject.vala"
		break;
#line 463 "AudioObject.c"
	}
}

static void
_vala_music_audio_object_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MusicAudioObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 6 "../src/AudioObject.vala"
	switch (property_id) {
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_URI_PROPERTY:
#line 6 "../src/AudioObject.vala"
		music_audio_object_set_uri (self, g_value_get_string (value));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_TEXTURE_PROPERTY:
#line 6 "../src/AudioObject.vala"
		music_audio_object_set_texture (self, g_value_get_object (value));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_ARTIST_PROPERTY:
#line 6 "../src/AudioObject.vala"
		music_audio_object_set_artist (self, g_value_get_string (value));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_TITLE_PROPERTY:
#line 6 "../src/AudioObject.vala"
		music_audio_object_set_title (self, g_value_get_string (value));
#line 6 "../src/AudioObject.vala"
		break;
#line 6 "../src/AudioObject.vala"
		case MUSIC_AUDIO_OBJECT_DURATION_PROPERTY:
#line 6 "../src/AudioObject.vala"
		music_audio_object_set_duration (self, g_value_get_int64 (value));
#line 6 "../src/AudioObject.vala"
		break;
#line 507 "AudioObject.c"
		default:
#line 6 "../src/AudioObject.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/AudioObject.vala"
		break;
#line 513 "AudioObject.c"
	}
}

