/* MprisPlayer.c generated by valac 0.56.14, the Vala compiler
 * generated from MprisPlayer.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2022 elementary, Inc. (https://elementary.io)
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define MUSIC_APPLICATION_ACTION_NEXT "action-next"
#define MUSIC_APPLICATION_ACTION_PREVIOUS "action-previous"
#define MUSIC_APPLICATION_ACTION_PLAY_PAUSE "action-play-pause"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_MPRIS_PLAYER (music_mpris_player_get_type ())
#define MUSIC_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayer))
#define MUSIC_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayerClass))
#define MUSIC_IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MPRIS_PLAYER))
#define MUSIC_IS_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MPRIS_PLAYER))
#define MUSIC_MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayerClass))

typedef struct _MusicMprisPlayer MusicMprisPlayer;
typedef struct _MusicMprisPlayerClass MusicMprisPlayerClass;
typedef struct _MusicMprisPlayerPrivate MusicMprisPlayerPrivate;

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
enum  {
	MUSIC_MPRIS_PLAYER_0_PROPERTY,
	MUSIC_MPRIS_PLAYER_CONNECTION_PROPERTY,
	MUSIC_MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY,
	MUSIC_MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY,
	MUSIC_MPRIS_PLAYER_CAN_PLAY_PROPERTY,
	MUSIC_MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY,
	MUSIC_MPRIS_PLAYER_METADATA_PROPERTY,
	MUSIC_MPRIS_PLAYER_NUM_PROPERTIES
};
static GParamSpec* music_mpris_player_properties[MUSIC_MPRIS_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

#define MUSIC_TYPE_AUDIO_OBJECT (music_audio_object_get_type ())
#define MUSIC_AUDIO_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject))
#define MUSIC_AUDIO_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObjectClass))
#define MUSIC_IS_AUDIO_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_AUDIO_OBJECT))
#define MUSIC_IS_AUDIO_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_AUDIO_OBJECT))
#define MUSIC_AUDIO_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObjectClass))

typedef struct _MusicAudioObject MusicAudioObject;
typedef struct _MusicAudioObjectClass MusicAudioObjectClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _MusicMprisPlayer {
	GObject parent_instance;
	MusicMprisPlayerPrivate * priv;
};

struct _MusicMprisPlayerClass {
	GObjectClass parent_class;
};

struct _MusicMprisPlayerPrivate {
	GDBusConnection* _connection;
	gboolean _can_go_next;
	gboolean _can_go_previous;
	gboolean _can_play;
	GApplication* application;
	MusicPlaybackManager* playback_manager;
};

static gint MusicMprisPlayer_private_offset;
static gpointer music_mpris_player_parent_class = NULL;

VALA_EXTERN GType music_mpris_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMprisPlayer, g_object_unref)
VALA_EXTERN guint music_mpris_player_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicMprisPlayer* music_mpris_player_new (GDBusConnection* connection);
VALA_EXTERN MusicMprisPlayer* music_mpris_player_construct (GType object_type,
                                                GDBusConnection* connection);
static void music_mpris_player_send_property_change (MusicMprisPlayer* self,
                                              const gchar* name,
                                              GVariant* variant);
VALA_EXTERN GDBusConnection* music_mpris_player_get_connection (MusicMprisPlayer* self);
VALA_EXTERN void music_mpris_player_next (MusicMprisPlayer* self,
                              GError** error);
VALA_EXTERN void music_mpris_player_previous (MusicMprisPlayer* self,
                                  GError** error);
VALA_EXTERN void music_mpris_player_play_pause (MusicMprisPlayer* self,
                                    GError** error);
static void music_mpris_player_set_connection (MusicMprisPlayer* self,
                                        GDBusConnection* value);
VALA_EXTERN gboolean music_mpris_player_get_can_go_next (MusicMprisPlayer* self);
VALA_EXTERN void music_mpris_player_set_can_go_next (MusicMprisPlayer* self,
                                         gboolean value);
VALA_EXTERN gboolean music_mpris_player_get_can_go_previous (MusicMprisPlayer* self);
VALA_EXTERN void music_mpris_player_set_can_go_previous (MusicMprisPlayer* self,
                                             gboolean value);
VALA_EXTERN gboolean music_mpris_player_get_can_play (MusicMprisPlayer* self);
VALA_EXTERN void music_mpris_player_set_can_play (MusicMprisPlayer* self,
                                      gboolean value);
VALA_EXTERN const gchar* music_mpris_player_get_playback_status (MusicMprisPlayer* self);
static gboolean _variant_get1 (GVariant* value);
VALA_EXTERN GHashTable* music_mpris_player_get_metadata (MusicMprisPlayer* self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
VALA_EXTERN GType music_audio_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicAudioObject, g_object_unref)
VALA_EXTERN MusicAudioObject* music_playback_manager_get_current_audio (MusicPlaybackManager* self);
VALA_EXTERN const gchar* music_audio_object_get_artist (MusicAudioObject* self);
static GVariant* _variant_new4 (gchar** value,
                         gint value_length1);
VALA_EXTERN const gchar* music_audio_object_get_title (MusicAudioObject* self);
static GVariant* _variant_new5 (const gchar* value);
static GObject * music_mpris_player_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
VALA_EXTERN MusicPlaybackManager* music_playback_manager_get_default (void);
static void _music_mpris_player___lambda9_ (MusicMprisPlayer* self);
static GVariant* _variant_new6 (GHashTable* value);
static void __music_mpris_player___lambda9__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _music_mpris_player___lambda10_ (MusicMprisPlayer* self,
                                      const gchar* name,
                                      GVariant* new_state);
static GVariant* _variant_new7 (const gchar* value);
static void __music_mpris_player___lambda10__g_action_group_action_state_changed (GActionGroup* _sender,
                                                                           const gchar* action_name,
                                                                           GVariant* state,
                                                                           gpointer self);
static void _music_mpris_player___lambda11_ (MusicMprisPlayer* self);
static GVariant* _variant_new8 (gboolean value);
static void __music_mpris_player___lambda11__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void _music_mpris_player___lambda12_ (MusicMprisPlayer* self);
static GVariant* _variant_new9 (gboolean value);
static void __music_mpris_player___lambda12__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void _music_mpris_player___lambda13_ (MusicMprisPlayer* self);
static GVariant* _variant_new10 (gboolean value);
static void __music_mpris_player___lambda13__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void music_mpris_player_finalize (GObject * obj);
static GType music_mpris_player_get_type_once (void);
static void _vala_music_mpris_player_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_music_mpris_player_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _dbus_music_mpris_player_next (MusicMprisPlayer* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_music_mpris_player_previous (MusicMprisPlayer* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation);
static void _dbus_music_mpris_player_play_pause (MusicMprisPlayer* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void music_mpris_player_dbus_interface_method_call (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* method_name,
                                                    GVariant* parameters,
                                                    GDBusMethodInvocation* invocation,
                                                    gpointer user_data);
static GVariant* music_mpris_player_dbus_interface_get_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GError** error,
                                                          gpointer user_data);
static GVariant* _dbus_music_mpris_player_get_can_go_next (MusicMprisPlayer* self);
static GVariant* _dbus_music_mpris_player_get_can_go_previous (MusicMprisPlayer* self);
static GVariant* _dbus_music_mpris_player_get_can_play (MusicMprisPlayer* self);
static GVariant* _dbus_music_mpris_player_get_playback_status (MusicMprisPlayer* self);
static GVariant* _dbus_music_mpris_player_get_metadata (MusicMprisPlayer* self);
static gboolean music_mpris_player_dbus_interface_set_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GVariant* value,
                                                         GError** error,
                                                         gpointer user_data);
static void _dbus_music_mpris_player_set_can_go_next (MusicMprisPlayer* self,
                                               GVariant* _value);
static void _dbus_music_mpris_player_set_can_go_previous (MusicMprisPlayer* self,
                                                   GVariant* _value);
static void _dbus_music_mpris_player_set_can_play (MusicMprisPlayer* self,
                                            GVariant* _value);
static void _music_mpris_player_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo * const _music_mpris_player_dbus_arg_info_next_in[] = {NULL};
static const GDBusArgInfo * const _music_mpris_player_dbus_arg_info_next_out[] = {NULL};
static const GDBusMethodInfo _music_mpris_player_dbus_method_info_next = {-1, "Next", (GDBusArgInfo **) (&_music_mpris_player_dbus_arg_info_next_in), (GDBusArgInfo **) (&_music_mpris_player_dbus_arg_info_next_out), NULL};
static const GDBusArgInfo * const _music_mpris_player_dbus_arg_info_previous_in[] = {NULL};
static const GDBusArgInfo * const _music_mpris_player_dbus_arg_info_previous_out[] = {NULL};
static const GDBusMethodInfo _music_mpris_player_dbus_method_info_previous = {-1, "Previous", (GDBusArgInfo **) (&_music_mpris_player_dbus_arg_info_previous_in), (GDBusArgInfo **) (&_music_mpris_player_dbus_arg_info_previous_out), NULL};
static const GDBusArgInfo * const _music_mpris_player_dbus_arg_info_play_pause_in[] = {NULL};
static const GDBusArgInfo * const _music_mpris_player_dbus_arg_info_play_pause_out[] = {NULL};
static const GDBusMethodInfo _music_mpris_player_dbus_method_info_play_pause = {-1, "PlayPause", (GDBusArgInfo **) (&_music_mpris_player_dbus_arg_info_play_pause_in), (GDBusArgInfo **) (&_music_mpris_player_dbus_arg_info_play_pause_out), NULL};
static const GDBusMethodInfo * const _music_mpris_player_dbus_method_info[] = {&_music_mpris_player_dbus_method_info_next, &_music_mpris_player_dbus_method_info_previous, &_music_mpris_player_dbus_method_info_play_pause, NULL};
static const GDBusSignalInfo * const _music_mpris_player_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _music_mpris_player_dbus_property_info_can_go_next = {-1, "CanGoNext", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _music_mpris_player_dbus_property_info_can_go_previous = {-1, "CanGoPrevious", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _music_mpris_player_dbus_property_info_can_play = {-1, "CanPlay", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _music_mpris_player_dbus_property_info_playback_status = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _music_mpris_player_dbus_property_info_metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _music_mpris_player_dbus_property_info[] = {&_music_mpris_player_dbus_property_info_can_go_next, &_music_mpris_player_dbus_property_info_can_go_previous, &_music_mpris_player_dbus_property_info_can_play, &_music_mpris_player_dbus_property_info_playback_status, &_music_mpris_player_dbus_property_info_metadata, NULL};
static const GDBusInterfaceInfo _music_mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_music_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_music_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_music_mpris_player_dbus_property_info), NULL};
static const GDBusInterfaceVTable _music_mpris_player_dbus_interface_vtable = {music_mpris_player_dbus_interface_method_call, music_mpris_player_dbus_interface_get_property, music_mpris_player_dbus_interface_set_property};

static inline gpointer
music_mpris_player_get_instance_private (MusicMprisPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMprisPlayer_private_offset);
}

MusicMprisPlayer*
music_mpris_player_construct (GType object_type,
                              GDBusConnection* connection)
{
	MusicMprisPlayer * self = NULL;
#line 49 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 50 "../src/DBus/MprisPlayer.vala"
	self = (MusicMprisPlayer*) g_object_new (object_type, "connection", connection, NULL);
#line 49 "../src/DBus/MprisPlayer.vala"
	return self;
#line 279 "MprisPlayer.c"
}

MusicMprisPlayer*
music_mpris_player_new (GDBusConnection* connection)
{
#line 49 "../src/DBus/MprisPlayer.vala"
	return music_mpris_player_construct (MUSIC_TYPE_MPRIS_PLAYER, connection);
#line 287 "MprisPlayer.c"
}

static void
music_mpris_player_send_property_change (MusicMprisPlayer* self,
                                         const gchar* name,
                                         GVariant* variant)
{
	GVariantBuilder* invalid_builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp4_;
	GVariantBuilder* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 81 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (name != NULL);
#line 81 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (variant != NULL);
#line 82 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = g_variant_type_new ("as");
#line 82 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = _tmp0_;
#line 82 "../src/DBus/MprisPlayer.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 82 "../src/DBus/MprisPlayer.vala"
	_tmp3_ = _tmp2_;
#line 82 "../src/DBus/MprisPlayer.vala"
	_g_variant_type_free0 (_tmp1_);
#line 82 "../src/DBus/MprisPlayer.vala"
	invalid_builder = _tmp3_;
#line 84 "../src/DBus/MprisPlayer.vala"
	_tmp4_ = G_VARIANT_TYPE_ARRAY;
#line 84 "../src/DBus/MprisPlayer.vala"
	_tmp5_ = g_variant_builder_new (_tmp4_);
#line 84 "../src/DBus/MprisPlayer.vala"
	builder = _tmp5_;
#line 85 "../src/DBus/MprisPlayer.vala"
	g_variant_builder_add (builder, "{sv}", name, variant, NULL);
#line 330 "MprisPlayer.c"
	{
		GDBusConnection* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
#line 88 "../src/DBus/MprisPlayer.vala"
		_tmp6_ = self->priv->_connection;
#line 88 "../src/DBus/MprisPlayer.vala"
		_tmp7_ = g_variant_new ("(sa{sv}as)", "org.mpris.MediaPlayer2.Player", builder, invalid_builder, NULL);
#line 88 "../src/DBus/MprisPlayer.vala"
		g_variant_ref_sink (_tmp7_);
#line 88 "../src/DBus/MprisPlayer.vala"
		_tmp8_ = _tmp7_;
#line 88 "../src/DBus/MprisPlayer.vala"
		g_dbus_connection_emit_signal (_tmp6_, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", _tmp8_, &_inner_error0_);
#line 88 "../src/DBus/MprisPlayer.vala"
		_g_variant_unref0 (_tmp8_);
#line 88 "../src/DBus/MprisPlayer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 349 "MprisPlayer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 87 "../src/DBus/MprisPlayer.vala"
		e = _inner_error0_;
#line 87 "../src/DBus/MprisPlayer.vala"
		_inner_error0_ = NULL;
#line 101 "../src/DBus/MprisPlayer.vala"
		_tmp9_ = e;
#line 101 "../src/DBus/MprisPlayer.vala"
		_tmp10_ = _tmp9_->message;
#line 101 "../src/DBus/MprisPlayer.vala"
		g_critical ("MprisPlayer.vala:101: Could not send MPRIS property change: %s", _tmp10_);
#line 87 "../src/DBus/MprisPlayer.vala"
		_g_error_free0 (e);
#line 371 "MprisPlayer.c"
	}
	__finally0:
#line 87 "../src/DBus/MprisPlayer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/DBus/MprisPlayer.vala"
		_g_variant_builder_unref0 (builder);
#line 87 "../src/DBus/MprisPlayer.vala"
		_g_variant_builder_unref0 (invalid_builder);
#line 87 "../src/DBus/MprisPlayer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../src/DBus/MprisPlayer.vala"
		g_clear_error (&_inner_error0_);
#line 87 "../src/DBus/MprisPlayer.vala"
		return;
#line 386 "MprisPlayer.c"
	}
#line 81 "../src/DBus/MprisPlayer.vala"
	_g_variant_builder_unref0 (builder);
#line 81 "../src/DBus/MprisPlayer.vala"
	_g_variant_builder_unref0 (invalid_builder);
#line 392 "MprisPlayer.c"
}

void
music_mpris_player_next (MusicMprisPlayer* self,
                         GError** error)
{
	GApplication* _tmp0_;
#line 105 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->application;
#line 106 "../src/DBus/MprisPlayer.vala"
	g_action_group_activate_action ((GActionGroup*) _tmp0_, MUSIC_APPLICATION_ACTION_NEXT, NULL);
#line 406 "MprisPlayer.c"
}

void
music_mpris_player_previous (MusicMprisPlayer* self,
                             GError** error)
{
	GApplication* _tmp0_;
#line 109 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->application;
#line 110 "../src/DBus/MprisPlayer.vala"
	g_action_group_activate_action ((GActionGroup*) _tmp0_, MUSIC_APPLICATION_ACTION_PREVIOUS, NULL);
#line 420 "MprisPlayer.c"
}

void
music_mpris_player_play_pause (MusicMprisPlayer* self,
                               GError** error)
{
	GApplication* _tmp0_;
#line 113 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->application;
#line 114 "../src/DBus/MprisPlayer.vala"
	g_action_group_activate_action ((GActionGroup*) _tmp0_, MUSIC_APPLICATION_ACTION_PLAY_PAUSE, NULL);
#line 434 "MprisPlayer.c"
}

GDBusConnection*
music_mpris_player_get_connection (MusicMprisPlayer* self)
{
	GDBusConnection* result;
	GDBusConnection* _tmp0_;
#line 9 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->_connection;
#line 9 "../src/DBus/MprisPlayer.vala"
	result = _tmp0_;
#line 9 "../src/DBus/MprisPlayer.vala"
	return result;
#line 450 "MprisPlayer.c"
}

static void
music_mpris_player_set_connection (MusicMprisPlayer* self,
                                   GDBusConnection* value)
{
	GDBusConnection* old_value;
#line 9 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/DBus/MprisPlayer.vala"
	old_value = music_mpris_player_get_connection (self);
#line 9 "../src/DBus/MprisPlayer.vala"
	if (old_value != value) {
#line 9 "../src/DBus/MprisPlayer.vala"
		self->priv->_connection = value;
#line 9 "../src/DBus/MprisPlayer.vala"
		g_object_notify_by_pspec ((GObject *) self, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CONNECTION_PROPERTY]);
#line 468 "MprisPlayer.c"
	}
}

gboolean
music_mpris_player_get_can_go_next (MusicMprisPlayer* self)
{
	gboolean result;
#line 11 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 11 "../src/DBus/MprisPlayer.vala"
	result = self->priv->_can_go_next;
#line 11 "../src/DBus/MprisPlayer.vala"
	return result;
#line 482 "MprisPlayer.c"
}

void
music_mpris_player_set_can_go_next (MusicMprisPlayer* self,
                                    gboolean value)
{
	gboolean old_value;
#line 11 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/DBus/MprisPlayer.vala"
	old_value = music_mpris_player_get_can_go_next (self);
#line 11 "../src/DBus/MprisPlayer.vala"
	if (old_value != value) {
#line 11 "../src/DBus/MprisPlayer.vala"
		self->priv->_can_go_next = value;
#line 11 "../src/DBus/MprisPlayer.vala"
		g_object_notify_by_pspec ((GObject *) self, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY]);
#line 500 "MprisPlayer.c"
	}
}

gboolean
music_mpris_player_get_can_go_previous (MusicMprisPlayer* self)
{
	gboolean result;
#line 12 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "../src/DBus/MprisPlayer.vala"
	result = self->priv->_can_go_previous;
#line 12 "../src/DBus/MprisPlayer.vala"
	return result;
#line 514 "MprisPlayer.c"
}

void
music_mpris_player_set_can_go_previous (MusicMprisPlayer* self,
                                        gboolean value)
{
	gboolean old_value;
#line 12 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/DBus/MprisPlayer.vala"
	old_value = music_mpris_player_get_can_go_previous (self);
#line 12 "../src/DBus/MprisPlayer.vala"
	if (old_value != value) {
#line 12 "../src/DBus/MprisPlayer.vala"
		self->priv->_can_go_previous = value;
#line 12 "../src/DBus/MprisPlayer.vala"
		g_object_notify_by_pspec ((GObject *) self, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY]);
#line 532 "MprisPlayer.c"
	}
}

gboolean
music_mpris_player_get_can_play (MusicMprisPlayer* self)
{
	gboolean result;
#line 13 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13 "../src/DBus/MprisPlayer.vala"
	result = self->priv->_can_play;
#line 13 "../src/DBus/MprisPlayer.vala"
	return result;
#line 546 "MprisPlayer.c"
}

void
music_mpris_player_set_can_play (MusicMprisPlayer* self,
                                 gboolean value)
{
	gboolean old_value;
#line 13 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/DBus/MprisPlayer.vala"
	old_value = music_mpris_player_get_can_play (self);
#line 13 "../src/DBus/MprisPlayer.vala"
	if (old_value != value) {
#line 13 "../src/DBus/MprisPlayer.vala"
		self->priv->_can_play = value;
#line 13 "../src/DBus/MprisPlayer.vala"
		g_object_notify_by_pspec ((GObject *) self, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CAN_PLAY_PROPERTY]);
#line 564 "MprisPlayer.c"
	}
}

static gboolean
_variant_get1 (GVariant* value)
{
#line 17 "../src/DBus/MprisPlayer.vala"
	return g_variant_get_boolean (value);
#line 573 "MprisPlayer.c"
}

const gchar*
music_mpris_player_get_playback_status (MusicMprisPlayer* self)
{
	const gchar* result;
	gboolean state = FALSE;
	GApplication* _tmp0_;
	GAction* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 16 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->application;
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) _tmp0_, MUSIC_APPLICATION_ACTION_PLAY_PAUSE);
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp2_ = g_action_get_state (_tmp1_);
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp3_ = _tmp2_;
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp4_ = _tmp3_;
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp5_ = _variant_get1 (_tmp4_);
#line 17 "../src/DBus/MprisPlayer.vala"
	_tmp6_ = _tmp5_;
#line 17 "../src/DBus/MprisPlayer.vala"
	_g_variant_unref0 (_tmp4_);
#line 17 "../src/DBus/MprisPlayer.vala"
	state = _tmp6_;
#line 18 "../src/DBus/MprisPlayer.vala"
	if (state == FALSE) {
#line 19 "../src/DBus/MprisPlayer.vala"
		result = "Stopped";
#line 19 "../src/DBus/MprisPlayer.vala"
		return result;
#line 614 "MprisPlayer.c"
	} else {
#line 21 "../src/DBus/MprisPlayer.vala"
		result = "Playing";
#line 21 "../src/DBus/MprisPlayer.vala"
		return result;
#line 620 "MprisPlayer.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 28 "../src/DBus/MprisPlayer.vala"
	var = (g_free (var), NULL);
#line 629 "MprisPlayer.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 28 "../src/DBus/MprisPlayer.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 637 "MprisPlayer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/DBus/MprisPlayer.vala"
	return self ? g_object_ref (self) : NULL;
#line 645 "MprisPlayer.c"
}

static GVariant*
_variant_new4 (gchar** value,
               gint value_length1)
{
	gchar** _tmp17_;
	GVariantBuilder _tmp18_;
	gint _tmp19_;
#line 34 "../src/DBus/MprisPlayer.vala"
	_tmp17_ = value;
#line 34 "../src/DBus/MprisPlayer.vala"
	g_variant_builder_init (&_tmp18_, G_VARIANT_TYPE ("as"));
#line 34 "../src/DBus/MprisPlayer.vala"
	for (_tmp19_ = 0; _tmp19_ < value_length1; _tmp19_++) {
#line 34 "../src/DBus/MprisPlayer.vala"
		g_variant_builder_add_value (&_tmp18_, g_variant_new_string (*_tmp17_));
#line 34 "../src/DBus/MprisPlayer.vala"
		_tmp17_++;
#line 665 "MprisPlayer.c"
	}
#line 34 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_builder_end (&_tmp18_));
#line 669 "MprisPlayer.c"
}

static GVariant*
_variant_new5 (const gchar* value)
{
#line 38 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 677 "MprisPlayer.c"
}

GHashTable*
music_mpris_player_get_metadata (MusicMprisPlayer* self)
{
	GHashTable* result;
	GHashTable* _metadata = NULL;
	GHashTable* _tmp0_;
	MusicAudioObject* audio = NULL;
	MusicPlaybackManager* _tmp1_;
	MusicAudioObject* _tmp2_;
	MusicAudioObject* _tmp3_;
	MusicAudioObject* _tmp4_;
	MusicAudioObject* _tmp5_;
#line 27 "../src/DBus/MprisPlayer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
#line 28 "../src/DBus/MprisPlayer.vala"
	_metadata = _tmp0_;
#line 30 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = self->priv->playback_manager;
#line 30 "../src/DBus/MprisPlayer.vala"
	_tmp2_ = music_playback_manager_get_current_audio (_tmp1_);
#line 30 "../src/DBus/MprisPlayer.vala"
	_tmp3_ = _tmp2_;
#line 30 "../src/DBus/MprisPlayer.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 30 "../src/DBus/MprisPlayer.vala"
	audio = _tmp4_;
#line 31 "../src/DBus/MprisPlayer.vala"
	_tmp5_ = audio;
#line 31 "../src/DBus/MprisPlayer.vala"
	if (_tmp5_ != NULL) {
#line 712 "MprisPlayer.c"
		MusicAudioObject* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		MusicAudioObject* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 32 "../src/DBus/MprisPlayer.vala"
		_tmp6_ = audio;
#line 32 "../src/DBus/MprisPlayer.vala"
		_tmp7_ = music_audio_object_get_artist (_tmp6_);
#line 32 "../src/DBus/MprisPlayer.vala"
		_tmp8_ = _tmp7_;
#line 32 "../src/DBus/MprisPlayer.vala"
		if (_tmp8_ != NULL) {
#line 727 "MprisPlayer.c"
			gchar** array = NULL;
			MusicAudioObject* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar** _tmp13_;
			gint array_length1;
			gint _array_size_;
			GHashTable* _tmp14_;
			gchar* _tmp15_;
			gchar** _tmp16_;
			gint _tmp16__length1;
			GVariant* _tmp20_;
#line 33 "../src/DBus/MprisPlayer.vala"
			_tmp9_ = audio;
#line 33 "../src/DBus/MprisPlayer.vala"
			_tmp10_ = music_audio_object_get_artist (_tmp9_);
#line 33 "../src/DBus/MprisPlayer.vala"
			_tmp11_ = _tmp10_;
#line 33 "../src/DBus/MprisPlayer.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 33 "../src/DBus/MprisPlayer.vala"
			_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 33 "../src/DBus/MprisPlayer.vala"
			_tmp13_[0] = _tmp12_;
#line 33 "../src/DBus/MprisPlayer.vala"
			array = _tmp13_;
#line 33 "../src/DBus/MprisPlayer.vala"
			array_length1 = 1;
#line 33 "../src/DBus/MprisPlayer.vala"
			_array_size_ = array_length1;
#line 34 "../src/DBus/MprisPlayer.vala"
			_tmp14_ = _metadata;
#line 34 "../src/DBus/MprisPlayer.vala"
			_tmp15_ = g_strdup ("xesam:artist");
#line 34 "../src/DBus/MprisPlayer.vala"
			_tmp16_ = array;
#line 34 "../src/DBus/MprisPlayer.vala"
			_tmp16__length1 = array_length1;
#line 34 "../src/DBus/MprisPlayer.vala"
			_tmp20_ = _variant_new4 (_tmp16_, _tmp16__length1);
#line 34 "../src/DBus/MprisPlayer.vala"
			g_hash_table_insert (_tmp14_, _tmp15_, _tmp20_);
#line 32 "../src/DBus/MprisPlayer.vala"
			array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_free), NULL);
#line 773 "MprisPlayer.c"
		}
#line 37 "../src/DBus/MprisPlayer.vala"
		_tmp21_ = audio;
#line 37 "../src/DBus/MprisPlayer.vala"
		_tmp22_ = music_audio_object_get_title (_tmp21_);
#line 37 "../src/DBus/MprisPlayer.vala"
		_tmp23_ = _tmp22_;
#line 37 "../src/DBus/MprisPlayer.vala"
		if (_tmp23_ != NULL) {
#line 783 "MprisPlayer.c"
			GHashTable* _tmp24_;
			gchar* _tmp25_;
			MusicAudioObject* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			GVariant* _tmp29_;
#line 38 "../src/DBus/MprisPlayer.vala"
			_tmp24_ = _metadata;
#line 38 "../src/DBus/MprisPlayer.vala"
			_tmp25_ = g_strdup ("xesam:title");
#line 38 "../src/DBus/MprisPlayer.vala"
			_tmp26_ = audio;
#line 38 "../src/DBus/MprisPlayer.vala"
			_tmp27_ = music_audio_object_get_title (_tmp26_);
#line 38 "../src/DBus/MprisPlayer.vala"
			_tmp28_ = _tmp27_;
#line 38 "../src/DBus/MprisPlayer.vala"
			_tmp29_ = _variant_new5 (_tmp28_);
#line 38 "../src/DBus/MprisPlayer.vala"
			g_hash_table_insert (_tmp24_, _tmp25_, _tmp29_);
#line 804 "MprisPlayer.c"
		}
	}
#line 42 "../src/DBus/MprisPlayer.vala"
	result = _metadata;
#line 42 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (audio);
#line 42 "../src/DBus/MprisPlayer.vala"
	return result;
#line 813 "MprisPlayer.c"
}

static GVariant*
_variant_new6 (GHashTable* value)
{
	GVariantBuilder _tmp3_;
	GHashTableIter _tmp4_;
	gpointer _tmp5_;
	gpointer _tmp6_;
#line 58 "../src/DBus/MprisPlayer.vala"
	g_hash_table_iter_init (&_tmp4_, value);
#line 58 "../src/DBus/MprisPlayer.vala"
	g_variant_builder_init (&_tmp3_, G_VARIANT_TYPE ("a{sv}"));
#line 58 "../src/DBus/MprisPlayer.vala"
	while (g_hash_table_iter_next (&_tmp4_, &_tmp5_, &_tmp6_)) {
#line 829 "MprisPlayer.c"
		gchar* _key;
		GVariant* _value;
#line 58 "../src/DBus/MprisPlayer.vala"
		_key = (gchar*) _tmp5_;
#line 58 "../src/DBus/MprisPlayer.vala"
		_value = (GVariant*) _tmp6_;
#line 58 "../src/DBus/MprisPlayer.vala"
		g_variant_builder_add (&_tmp3_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
#line 838 "MprisPlayer.c"
	}
#line 58 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_builder_end (&_tmp3_));
#line 842 "MprisPlayer.c"
}

static void
_music_mpris_player___lambda9_ (MusicMprisPlayer* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GHashTable* _tmp2_;
	GVariant* _tmp7_;
#line 58 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = music_mpris_player_get_metadata (self);
#line 58 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/DBus/MprisPlayer.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/DBus/MprisPlayer.vala"
	_tmp7_ = _variant_new6 (_tmp2_);
#line 58 "../src/DBus/MprisPlayer.vala"
	music_mpris_player_send_property_change (self, "Metadata", _tmp7_);
#line 58 "../src/DBus/MprisPlayer.vala"
	_g_variant_unref0 (_tmp7_);
#line 58 "../src/DBus/MprisPlayer.vala"
	_g_hash_table_unref0 (_tmp2_);
#line 866 "MprisPlayer.c"
}

static void
__music_mpris_player___lambda9__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 57 "../src/DBus/MprisPlayer.vala"
	_music_mpris_player___lambda9_ ((MusicMprisPlayer*) self);
#line 876 "MprisPlayer.c"
}

static GVariant*
_variant_new7 (const gchar* value)
{
#line 63 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 884 "MprisPlayer.c"
}

static void
_music_mpris_player___lambda10_ (MusicMprisPlayer* self,
                                 const gchar* name,
                                 GVariant* new_state)
{
#line 61 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (name != NULL);
#line 61 "../src/DBus/MprisPlayer.vala"
	g_return_if_fail (new_state != NULL);
#line 62 "../src/DBus/MprisPlayer.vala"
	if (g_strcmp0 (name, MUSIC_APPLICATION_ACTION_PLAY_PAUSE) == 0) {
#line 898 "MprisPlayer.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		GVariant* _tmp2_;
#line 63 "../src/DBus/MprisPlayer.vala"
		_tmp0_ = music_mpris_player_get_playback_status (self);
#line 63 "../src/DBus/MprisPlayer.vala"
		_tmp1_ = _tmp0_;
#line 63 "../src/DBus/MprisPlayer.vala"
		_tmp2_ = _variant_new7 (_tmp1_);
#line 63 "../src/DBus/MprisPlayer.vala"
		music_mpris_player_send_property_change (self, "PlaybackStatus", _tmp2_);
#line 63 "../src/DBus/MprisPlayer.vala"
		_g_variant_unref0 (_tmp2_);
#line 912 "MprisPlayer.c"
	}
}

static void
__music_mpris_player___lambda10__g_action_group_action_state_changed (GActionGroup* _sender,
                                                                      const gchar* action_name,
                                                                      GVariant* state,
                                                                      gpointer self)
{
#line 61 "../src/DBus/MprisPlayer.vala"
	_music_mpris_player___lambda10_ ((MusicMprisPlayer*) self, action_name, state);
#line 924 "MprisPlayer.c"
}

static GVariant*
_variant_new8 (gboolean value)
{
#line 76 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 932 "MprisPlayer.c"
}

static void
_music_mpris_player___lambda11_ (MusicMprisPlayer* self)
{
	gboolean _tmp0_;
	GVariant* _tmp1_;
#line 76 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->_can_go_next;
#line 76 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = _variant_new8 (_tmp0_);
#line 76 "../src/DBus/MprisPlayer.vala"
	music_mpris_player_send_property_change (self, "CanGoNext", _tmp1_);
#line 76 "../src/DBus/MprisPlayer.vala"
	_g_variant_unref0 (_tmp1_);
#line 948 "MprisPlayer.c"
}

static void
__music_mpris_player___lambda11__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 76 "../src/DBus/MprisPlayer.vala"
	_music_mpris_player___lambda11_ ((MusicMprisPlayer*) self);
#line 958 "MprisPlayer.c"
}

static GVariant*
_variant_new9 (gboolean value)
{
#line 77 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 966 "MprisPlayer.c"
}

static void
_music_mpris_player___lambda12_ (MusicMprisPlayer* self)
{
	gboolean _tmp0_;
	GVariant* _tmp1_;
#line 77 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->_can_go_previous;
#line 77 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = _variant_new9 (_tmp0_);
#line 77 "../src/DBus/MprisPlayer.vala"
	music_mpris_player_send_property_change (self, "CanGoPrevious", _tmp1_);
#line 77 "../src/DBus/MprisPlayer.vala"
	_g_variant_unref0 (_tmp1_);
#line 982 "MprisPlayer.c"
}

static void
__music_mpris_player___lambda12__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 77 "../src/DBus/MprisPlayer.vala"
	_music_mpris_player___lambda12_ ((MusicMprisPlayer*) self);
#line 992 "MprisPlayer.c"
}

static GVariant*
_variant_new10 (gboolean value)
{
#line 78 "../src/DBus/MprisPlayer.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1000 "MprisPlayer.c"
}

static void
_music_mpris_player___lambda13_ (MusicMprisPlayer* self)
{
	gboolean _tmp0_;
	GVariant* _tmp1_;
#line 78 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = self->priv->_can_play;
#line 78 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = _variant_new10 (_tmp0_);
#line 78 "../src/DBus/MprisPlayer.vala"
	music_mpris_player_send_property_change (self, "CanPlay", _tmp1_);
#line 78 "../src/DBus/MprisPlayer.vala"
	_g_variant_unref0 (_tmp1_);
#line 1016 "MprisPlayer.c"
}

static void
__music_mpris_player___lambda13__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 78 "../src/DBus/MprisPlayer.vala"
	_music_mpris_player___lambda13_ ((MusicMprisPlayer*) self);
#line 1026 "MprisPlayer.c"
}

static GObject *
music_mpris_player_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMprisPlayer * self;
	GApplication* _tmp0_;
	GApplication* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	GApplication* _tmp5_;
	GAction* action_next = NULL;
	GApplication* _tmp6_;
	GAction* _tmp7_;
	GAction* _tmp8_;
	GAction* _tmp9_;
	GAction* action_play_pause = NULL;
	GApplication* _tmp10_;
	GAction* _tmp11_;
	GAction* _tmp12_;
	GAction* _tmp13_;
	GAction* action_previous = NULL;
	GApplication* _tmp14_;
	GAction* _tmp15_;
	GAction* _tmp16_;
	GAction* _tmp17_;
#line 53 "../src/DBus/MprisPlayer.vala"
	parent_class = G_OBJECT_CLASS (music_mpris_player_parent_class);
#line 53 "../src/DBus/MprisPlayer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/DBus/MprisPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayer);
#line 54 "../src/DBus/MprisPlayer.vala"
	_tmp0_ = g_application_get_default ();
#line 54 "../src/DBus/MprisPlayer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 54 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (self->priv->application);
#line 54 "../src/DBus/MprisPlayer.vala"
	self->priv->application = _tmp1_;
#line 55 "../src/DBus/MprisPlayer.vala"
	_tmp2_ = music_playback_manager_get_default ();
#line 55 "../src/DBus/MprisPlayer.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 55 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (self->priv->playback_manager);
#line 55 "../src/DBus/MprisPlayer.vala"
	self->priv->playback_manager = _tmp3_;
#line 57 "../src/DBus/MprisPlayer.vala"
	_tmp4_ = self->priv->playback_manager;
#line 57 "../src/DBus/MprisPlayer.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::current-audio", (GCallback) __music_mpris_player___lambda9__g_object_notify, self, 0);
#line 61 "../src/DBus/MprisPlayer.vala"
	_tmp5_ = self->priv->application;
#line 61 "../src/DBus/MprisPlayer.vala"
	g_signal_connect_object ((GActionGroup*) _tmp5_, "action-state-changed", (GCallback) __music_mpris_player___lambda10__g_action_group_action_state_changed, self, 0);
#line 67 "../src/DBus/MprisPlayer.vala"
	_tmp6_ = self->priv->application;
#line 67 "../src/DBus/MprisPlayer.vala"
	_tmp7_ = g_action_map_lookup_action ((GActionMap*) _tmp6_, MUSIC_APPLICATION_ACTION_NEXT);
#line 67 "../src/DBus/MprisPlayer.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 67 "../src/DBus/MprisPlayer.vala"
	action_next = _tmp8_;
#line 68 "../src/DBus/MprisPlayer.vala"
	_tmp9_ = action_next;
#line 68 "../src/DBus/MprisPlayer.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp9_, "enabled", (GObject*) self, "can-go-next", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 70 "../src/DBus/MprisPlayer.vala"
	_tmp10_ = self->priv->application;
#line 70 "../src/DBus/MprisPlayer.vala"
	_tmp11_ = g_action_map_lookup_action ((GActionMap*) _tmp10_, MUSIC_APPLICATION_ACTION_PLAY_PAUSE);
#line 70 "../src/DBus/MprisPlayer.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 70 "../src/DBus/MprisPlayer.vala"
	action_play_pause = _tmp12_;
#line 71 "../src/DBus/MprisPlayer.vala"
	_tmp13_ = action_play_pause;
#line 71 "../src/DBus/MprisPlayer.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp13_, "enabled", (GObject*) self, "can-play", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 73 "../src/DBus/MprisPlayer.vala"
	_tmp14_ = self->priv->application;
#line 73 "../src/DBus/MprisPlayer.vala"
	_tmp15_ = g_action_map_lookup_action ((GActionMap*) _tmp14_, MUSIC_APPLICATION_ACTION_PREVIOUS);
#line 73 "../src/DBus/MprisPlayer.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 73 "../src/DBus/MprisPlayer.vala"
	action_previous = _tmp16_;
#line 74 "../src/DBus/MprisPlayer.vala"
	_tmp17_ = action_previous;
#line 74 "../src/DBus/MprisPlayer.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp17_, "enabled", (GObject*) self, "can-go-previous", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 76 "../src/DBus/MprisPlayer.vala"
	g_signal_connect_object ((GObject*) self, "notify::can-go-next", (GCallback) __music_mpris_player___lambda11__g_object_notify, self, 0);
#line 77 "../src/DBus/MprisPlayer.vala"
	g_signal_connect_object ((GObject*) self, "notify::can-go-previous", (GCallback) __music_mpris_player___lambda12__g_object_notify, self, 0);
#line 78 "../src/DBus/MprisPlayer.vala"
	g_signal_connect_object ((GObject*) self, "notify::can-play", (GCallback) __music_mpris_player___lambda13__g_object_notify, self, 0);
#line 53 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (action_previous);
#line 53 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (action_play_pause);
#line 53 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (action_next);
#line 53 "../src/DBus/MprisPlayer.vala"
	return obj;
#line 1138 "MprisPlayer.c"
}

static void
music_mpris_player_class_init (MusicMprisPlayerClass * klass,
                               gpointer klass_data)
{
#line 7 "../src/DBus/MprisPlayer.vala"
	music_mpris_player_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/DBus/MprisPlayer.vala"
	g_type_class_adjust_private_offset (klass, &MusicMprisPlayer_private_offset);
#line 7 "../src/DBus/MprisPlayer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_mpris_player_get_property;
#line 7 "../src/DBus/MprisPlayer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_mpris_player_set_property;
#line 7 "../src/DBus/MprisPlayer.vala"
	G_OBJECT_CLASS (klass)->constructor = music_mpris_player_constructor;
#line 7 "../src/DBus/MprisPlayer.vala"
	G_OBJECT_CLASS (klass)->finalize = music_mpris_player_finalize;
#line 7 "../src/DBus/MprisPlayer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MPRIS_PLAYER_CONNECTION_PROPERTY, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", g_dbus_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../src/DBus/MprisPlayer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY] = g_param_spec_boolean ("can-go-next", "can-go-next", "can-go-next", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../src/DBus/MprisPlayer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY] = g_param_spec_boolean ("can-go-previous", "can-go-previous", "can-go-previous", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../src/DBus/MprisPlayer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MPRIS_PLAYER_CAN_PLAY_PROPERTY, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_CAN_PLAY_PROPERTY] = g_param_spec_boolean ("can-play", "can-play", "can-play", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../src/DBus/MprisPlayer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY] = g_param_spec_string ("playback-status", "playback-status", "playback-status", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/DBus/MprisPlayer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MPRIS_PLAYER_METADATA_PROPERTY, music_mpris_player_properties[MUSIC_MPRIS_PLAYER_METADATA_PROPERTY] = g_param_spec_boxed ("metadata", "metadata", "metadata", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1169 "MprisPlayer.c"
}

static void
music_mpris_player_instance_init (MusicMprisPlayer * self,
                                  gpointer klass)
{
#line 7 "../src/DBus/MprisPlayer.vala"
	self->priv = music_mpris_player_get_instance_private (self);
#line 1178 "MprisPlayer.c"
}

static void
music_mpris_player_finalize (GObject * obj)
{
	MusicMprisPlayer * self;
#line 7 "../src/DBus/MprisPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayer);
#line 46 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (self->priv->application);
#line 47 "../src/DBus/MprisPlayer.vala"
	_g_object_unref0 (self->priv->playback_manager);
#line 7 "../src/DBus/MprisPlayer.vala"
	G_OBJECT_CLASS (music_mpris_player_parent_class)->finalize (obj);
#line 1193 "MprisPlayer.c"
}

static GType
music_mpris_player_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMprisPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMprisPlayer), 0, (GInstanceInitFunc) music_mpris_player_instance_init, NULL };
	GType music_mpris_player_type_id;
	music_mpris_player_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicMprisPlayer", &g_define_type_info, 0);
	g_type_set_qdata (music_mpris_player_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) music_mpris_player_register_object);
	MusicMprisPlayer_private_offset = g_type_add_instance_private (music_mpris_player_type_id, sizeof (MusicMprisPlayerPrivate));
	return music_mpris_player_type_id;
}

GType
music_mpris_player_get_type (void)
{
	static volatile gsize music_mpris_player_type_id__once = 0;
	if (g_once_init_enter (&music_mpris_player_type_id__once)) {
		GType music_mpris_player_type_id;
		music_mpris_player_type_id = music_mpris_player_get_type_once ();
		g_once_init_leave (&music_mpris_player_type_id__once, music_mpris_player_type_id);
	}
	return music_mpris_player_type_id__once;
}

static void
_vala_music_mpris_player_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MusicMprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayer);
#line 7 "../src/DBus/MprisPlayer.vala"
	switch (property_id) {
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CONNECTION_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		g_value_set_object (value, music_mpris_player_get_connection (self));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		g_value_set_boolean (value, music_mpris_player_get_can_go_next (self));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		g_value_set_boolean (value, music_mpris_player_get_can_go_previous (self));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CAN_PLAY_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		g_value_set_boolean (value, music_mpris_player_get_can_play (self));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		g_value_set_string (value, music_mpris_player_get_playback_status (self));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_METADATA_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		g_value_take_boxed (value, music_mpris_player_get_metadata (self));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 1265 "MprisPlayer.c"
		default:
#line 7 "../src/DBus/MprisPlayer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 1271 "MprisPlayer.c"
	}
}

static void
_vala_music_mpris_player_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MusicMprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MPRIS_PLAYER, MusicMprisPlayer);
#line 7 "../src/DBus/MprisPlayer.vala"
	switch (property_id) {
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CONNECTION_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		music_mpris_player_set_connection (self, g_value_get_object (value));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		music_mpris_player_set_can_go_next (self, g_value_get_boolean (value));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		music_mpris_player_set_can_go_previous (self, g_value_get_boolean (value));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 7 "../src/DBus/MprisPlayer.vala"
		case MUSIC_MPRIS_PLAYER_CAN_PLAY_PROPERTY:
#line 7 "../src/DBus/MprisPlayer.vala"
		music_mpris_player_set_can_play (self, g_value_get_boolean (value));
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 1309 "MprisPlayer.c"
		default:
#line 7 "../src/DBus/MprisPlayer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/DBus/MprisPlayer.vala"
		break;
#line 1315 "MprisPlayer.c"
	}
}

static void
_dbus_music_mpris_player_next (MusicMprisPlayer* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	music_mpris_player_next (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_music_mpris_player_previous (MusicMprisPlayer* self,
                                   GVariant* _parameters_,
                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	music_mpris_player_previous (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_music_mpris_player_play_pause (MusicMprisPlayer* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	music_mpris_player_play_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
music_mpris_player_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_music_mpris_player_next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_music_mpris_player_previous (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_music_mpris_player_play_pause (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_music_mpris_player_get_can_go_next (MusicMprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = music_mpris_player_get_can_go_next (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_music_mpris_player_get_can_go_previous (MusicMprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = music_mpris_player_get_can_go_previous (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_music_mpris_player_get_can_play (MusicMprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = music_mpris_player_get_can_play (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_music_mpris_player_get_playback_status (MusicMprisPlayer* self)
{
	const gchar* result;
	GVariant* _reply;
	result = music_mpris_player_get_playback_status (self);
	_reply = g_variant_new_string (result);
	return _reply;
}

static GVariant*
_dbus_music_mpris_player_get_metadata (MusicMprisPlayer* self)
{
	GHashTable* result;
	GVariant* _reply;
	GVariantBuilder _tmp0_;
	GHashTableIter _tmp1_;
	gpointer _tmp2_;
	gpointer _tmp3_;
	result = music_mpris_player_get_metadata (self);
	g_hash_table_iter_init (&_tmp1_, result);
	g_variant_builder_init (&_tmp0_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp1_, &_tmp2_, &_tmp3_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp2_;
		_value = (GVariant*) _tmp3_;
		g_variant_builder_add (&_tmp0_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp0_);
	_g_hash_table_unref0 (result);
	return _reply;
}

static GVariant*
music_mpris_player_dbus_interface_get_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "CanGoNext") == 0) {
		return _dbus_music_mpris_player_get_can_go_next (object);
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		return _dbus_music_mpris_player_get_can_go_previous (object);
	} else if (strcmp (property_name, "CanPlay") == 0) {
		return _dbus_music_mpris_player_get_can_play (object);
	} else if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_music_mpris_player_get_playback_status (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_music_mpris_player_get_metadata (object);
	}
	return NULL;
}

static void
_dbus_music_mpris_player_set_can_go_next (MusicMprisPlayer* self,
                                          GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	music_mpris_player_set_can_go_next (self, value);
}

static void
_dbus_music_mpris_player_set_can_go_previous (MusicMprisPlayer* self,
                                              GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	music_mpris_player_set_can_go_previous (self, value);
}

static void
_dbus_music_mpris_player_set_can_play (MusicMprisPlayer* self,
                                       GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	music_mpris_player_set_can_play (self, value);
}

static gboolean
music_mpris_player_dbus_interface_set_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GVariant* value,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "CanGoNext") == 0) {
		_dbus_music_mpris_player_set_can_go_next (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		_dbus_music_mpris_player_set_can_go_previous (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanPlay") == 0) {
		_dbus_music_mpris_player_set_can_play (object, value);
		return TRUE;
	}
	return FALSE;
}

guint
music_mpris_player_register_object (gpointer object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_music_mpris_player_dbus_interface_info), &_music_mpris_player_dbus_interface_vtable, data, _music_mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_music_mpris_player_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

