/* PlaybackManager.c generated by valac 0.56.14, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2021-2022 elementary, Inc. (https://elementary.io)
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <gst/gst.h>
#include <gst/pbutils/pbutils.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/tag/tag.h>

#define MUSIC_APPLICATION_ACTION_PLAY_PAUSE "action-play-pause"
#define MUSIC_APPLICATION_ACTION_NEXT "action-next"
#define MUSIC_APPLICATION_ACTION_PREVIOUS "action-previous"
#define MUSIC_APPLICATION_ACTION_SHUFFLE "action-shuffle"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
typedef struct _MusicPlaybackManagerPrivate MusicPlaybackManagerPrivate;

#define MUSIC_TYPE_AUDIO_OBJECT (music_audio_object_get_type ())
#define MUSIC_AUDIO_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject))
#define MUSIC_AUDIO_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObjectClass))
#define MUSIC_IS_AUDIO_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_AUDIO_OBJECT))
#define MUSIC_IS_AUDIO_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_AUDIO_OBJECT))
#define MUSIC_AUDIO_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObjectClass))

typedef struct _MusicAudioObject MusicAudioObject;
typedef struct _MusicAudioObjectClass MusicAudioObjectClass;
typedef enum  {
	MUSIC_PLAYBACK_MANAGER_DIRECTION_NONE,
	MUSIC_PLAYBACK_MANAGER_DIRECTION_NEXT,
	MUSIC_PLAYBACK_MANAGER_DIRECTION_PREVIOUS
} MusicPlaybackManagerDirection;

#define MUSIC_PLAYBACK_MANAGER_TYPE_DIRECTION (music_playback_manager_direction_get_type ())
enum  {
	MUSIC_PLAYBACK_MANAGER_0_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_AUDIO_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_QUEUE_LISTSTORE_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_POSITION_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gst_buffer_unref0(var) ((var == NULL) ? NULL : (var = (gst_buffer_unref (var), NULL)))
#define _gst_sample_unref0(var) ((var == NULL) ? NULL : (var = (gst_sample_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	MUSIC_PLAYBACK_MANAGER_INVALIDS_FOUND_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _MusicPlaybackManager {
	GObject parent_instance;
	MusicPlaybackManagerPrivate * priv;
};

struct _MusicPlaybackManagerClass {
	GObjectClass parent_class;
};

struct _MusicPlaybackManagerPrivate {
	MusicAudioObject* _current_audio;
	GListStore* _queue_liststore;
	gint64 _playback_position;
	GstElement* playbin;
	GstDiscoverer* discoverer;
	guint progress_timer;
	GSettings* settings;
	gboolean next_by_eos;
	MusicPlaybackManagerDirection direction;
};

static gint MusicPlaybackManager_private_offset;
static gpointer music_playback_manager_parent_class = NULL;
static GOnce music_playback_manager_instance;
static GOnce music_playback_manager_instance = G_ONCE_INIT;

VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN GType music_audio_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicAudioObject, g_object_unref)
static GType music_playback_manager_direction_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN MusicPlaybackManager* music_playback_manager_get_default (void);
static MusicPlaybackManager* __lambda4_ (void);
static MusicPlaybackManager* music_playback_manager_new (void);
static MusicPlaybackManager* music_playback_manager_construct (GType object_type);
static gpointer ___lambda4__gthread_func (gpointer self);
VALA_EXTERN void music_playback_manager_seek_to_progress (MusicPlaybackManager* self,
                                              gdouble percent);
VALA_EXTERN MusicAudioObject* music_playback_manager_get_current_audio (MusicPlaybackManager* self);
VALA_EXTERN gint64 music_audio_object_get_duration (MusicAudioObject* self);
VALA_EXTERN void music_playback_manager_queue_files (MusicPlaybackManager* self,
                                         GFile** files,
                                         gint files_length1);
VALA_EXTERN MusicAudioObject* music_audio_object_new (const gchar* uri);
VALA_EXTERN MusicAudioObject* music_audio_object_construct (GType object_type,
                                                const gchar* uri);
VALA_EXTERN void music_audio_object_set_title (MusicAudioObject* self,
                                   const gchar* value);
VALA_EXTERN const gchar* music_audio_object_get_uri (MusicAudioObject* self);
VALA_EXTERN GListStore* music_playback_manager_get_queue_liststore (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_set_current_audio (MusicPlaybackManager* self,
                                               MusicAudioObject* value);
static void music_playback_manager_update_metadata (MusicPlaybackManager* self,
                                             GstDiscovererInfo* info,
                                             GError* err);
static gboolean __lambda5_ (const gchar* a,
                     const gchar* b);
static gboolean ___lambda5__gequal_func (gconstpointer a,
                                  gconstpointer b);
VALA_EXTERN void music_audio_object_set_duration (MusicAudioObject* self,
                                      gint64 value);
VALA_EXTERN void music_audio_object_set_artist (MusicAudioObject* self,
                                    const gchar* value);
static GstSample* music_playback_manager_get_cover_sample (MusicPlaybackManager* self,
                                                    GstTagList* tag_list);
static GdkPixbuf* music_playback_manager_get_pixbuf_from_buffer (MusicPlaybackManager* self,
                                                          GstBuffer* buffer);
VALA_EXTERN void music_audio_object_set_texture (MusicAudioObject* self,
                                     GdkTexture* value);
static gboolean music_playback_manager_bus_callback (MusicPlaybackManager* self,
                                              GstBus* bus,
                                              GstMessage* message);
VALA_EXTERN void music_playback_manager_next (MusicPlaybackManager* self,
                                  gboolean eos);
VALA_EXTERN void music_playback_manager_previous (MusicPlaybackManager* self);
static GVariant* _variant_new2 (gboolean value);
static gboolean ____lambda6_ (MusicPlaybackManager* self);
static void music_playback_manager_set_playback_position (MusicPlaybackManager* self,
                                                   gint64 value);
static gboolean _____lambda6__gsource_func (gpointer self);
static GVariant* _variant_new3 (gboolean value);
VALA_EXTERN void music_playback_manager_play_pause (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_shuffle (MusicPlaybackManager* self);
static void music_playback_manager_update_next_previous_sensitivity (MusicPlaybackManager* self);
static void music_playback_manager_set_queue_liststore (MusicPlaybackManager* self,
                                                 GListStore* value);
VALA_EXTERN gint64 music_playback_manager_get_playback_position (MusicPlaybackManager* self);
static GObject * music_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static gboolean _music_playback_manager_bus_callback_gst_bus_func (GstBus* bus,
                                                            GstMessage* message,
                                                            gpointer self);
static void _music_playback_manager_update_metadata_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                        GstDiscovererInfo* info,
                                                                        GError* err,
                                                                        gpointer self);
static void _gst_discoverer_stop_gst_discoverer_finished (GstDiscoverer* _sender,
                                                   gpointer self);
static void _music_playback_manager___lambda7_ (MusicPlaybackManager* self);
static void __music_playback_manager___lambda7__g_list_model_items_changed (GListModel* _sender,
                                                                     guint position,
                                                                     guint removed,
                                                                     guint added,
                                                                     gpointer self);
static void _music_playback_manager___lambda8_ (MusicPlaybackManager* self);
static void __music_playback_manager___lambda8__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void music_playback_manager_finalize (GObject * obj);
static GType music_playback_manager_get_type_once (void);
static void _vala_music_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
music_playback_manager_get_instance_private (MusicPlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaybackManager_private_offset);
}

static GType
music_playback_manager_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_PLAYBACK_MANAGER_DIRECTION_NONE, "MUSIC_PLAYBACK_MANAGER_DIRECTION_NONE", "none"}, {MUSIC_PLAYBACK_MANAGER_DIRECTION_NEXT, "MUSIC_PLAYBACK_MANAGER_DIRECTION_NEXT", "next"}, {MUSIC_PLAYBACK_MANAGER_DIRECTION_PREVIOUS, "MUSIC_PLAYBACK_MANAGER_DIRECTION_PREVIOUS", "previous"}, {0, NULL, NULL}};
	GType music_playback_manager_direction_type_id;
	music_playback_manager_direction_type_id = g_enum_register_static ("MusicPlaybackManagerDirection", values);
	return music_playback_manager_direction_type_id;
}

static GType
music_playback_manager_direction_get_type (void)
{
	static volatile gsize music_playback_manager_direction_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_direction_type_id__once)) {
		GType music_playback_manager_direction_type_id;
		music_playback_manager_direction_type_id = music_playback_manager_direction_get_type_once ();
		g_once_init_leave (&music_playback_manager_direction_type_id__once, music_playback_manager_direction_type_id);
	}
	return music_playback_manager_direction_type_id__once;
}

static MusicPlaybackManager*
__lambda4_ (void)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* result;
#line 14 "../src/PlaybackManager.vala"
	_tmp0_ = music_playback_manager_new ();
#line 14 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 14 "../src/PlaybackManager.vala"
	return result;
#line 251 "PlaybackManager.c"
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ ();
#line 14 "../src/PlaybackManager.vala"
	return result;
#line 261 "PlaybackManager.c"
}

MusicPlaybackManager*
music_playback_manager_get_default (void)
{
	gconstpointer _tmp0_;
	MusicPlaybackManager* result;
#line 14 "../src/PlaybackManager.vala"
	_tmp0_ = g_once (&music_playback_manager_instance, ___lambda4__gthread_func, NULL);
#line 14 "../src/PlaybackManager.vala"
	result = (MusicPlaybackManager*) _tmp0_;
#line 14 "../src/PlaybackManager.vala"
	return result;
#line 275 "PlaybackManager.c"
}

static MusicPlaybackManager*
music_playback_manager_construct (GType object_type)
{
	MusicPlaybackManager * self = NULL;
#line 32 "../src/PlaybackManager.vala"
	self = (MusicPlaybackManager*) g_object_new (object_type, NULL);
#line 32 "../src/PlaybackManager.vala"
	return self;
#line 286 "PlaybackManager.c"
}

static MusicPlaybackManager*
music_playback_manager_new (void)
{
#line 32 "../src/PlaybackManager.vala"
	return music_playback_manager_construct (MUSIC_TYPE_PLAYBACK_MANAGER);
#line 294 "PlaybackManager.c"
}

void
music_playback_manager_seek_to_progress (MusicPlaybackManager* self,
                                         gdouble percent)
{
	GstElement* _tmp0_;
	MusicAudioObject* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
#line 82 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 83 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_audio;
#line 83 "../src/PlaybackManager.vala"
	_tmp2_ = music_audio_object_get_duration (_tmp1_);
#line 83 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 83 "../src/PlaybackManager.vala"
	gst_element_seek_simple (_tmp0_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, (gint64) (percent * _tmp3_));
#line 317 "PlaybackManager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 336 "PlaybackManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 122 "../src/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 344 "PlaybackManager.c"
}

void
music_playback_manager_queue_files (MusicPlaybackManager* self,
                                    GFile** files,
                                    gint files_length1)
{
	GstDiscoverer* _tmp0_;
	gint invalids = 0;
	MusicAudioObject* _tmp29_;
#line 87 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->discoverer;
#line 88 "../src/PlaybackManager.vala"
	gst_discoverer_start (_tmp0_);
#line 89 "../src/PlaybackManager.vala"
	invalids = 0;
#line 363 "PlaybackManager.c"
	{
		GFile** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it = 0;
#line 90 "../src/PlaybackManager.vala"
		file_collection = files;
#line 90 "../src/PlaybackManager.vala"
		file_collection_length1 = files_length1;
#line 90 "../src/PlaybackManager.vala"
		for (file_it = 0; file_it < file_collection_length1; file_it = file_it + 1) {
#line 375 "PlaybackManager.c"
			GFile* file = NULL;
#line 90 "../src/PlaybackManager.vala"
			file = file_collection[file_it];
#line 379 "PlaybackManager.c"
			{
				gboolean _tmp1_ = FALSE;
				GFile* _tmp2_;
#line 91 "../src/PlaybackManager.vala"
				_tmp2_ = file;
#line 91 "../src/PlaybackManager.vala"
				if (g_file_query_exists (_tmp2_, NULL)) {
#line 387 "PlaybackManager.c"
					GFile* _tmp3_;
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
#line 91 "../src/PlaybackManager.vala"
					_tmp3_ = file;
#line 91 "../src/PlaybackManager.vala"
					_tmp4_ = g_file_get_uri (_tmp3_);
#line 91 "../src/PlaybackManager.vala"
					_tmp5_ = _tmp4_;
#line 91 "../src/PlaybackManager.vala"
					_tmp6_ = g_content_type_guess (_tmp5_, NULL, (gsize) 0, NULL);
#line 91 "../src/PlaybackManager.vala"
					_tmp7_ = _tmp6_;
#line 91 "../src/PlaybackManager.vala"
					_tmp1_ = string_contains (_tmp7_, "audio");
#line 91 "../src/PlaybackManager.vala"
					_g_free0 (_tmp7_);
#line 91 "../src/PlaybackManager.vala"
					_g_free0 (_tmp5_);
#line 409 "PlaybackManager.c"
				} else {
#line 91 "../src/PlaybackManager.vala"
					_tmp1_ = FALSE;
#line 413 "PlaybackManager.c"
				}
#line 91 "../src/PlaybackManager.vala"
				if (_tmp1_) {
#line 417 "PlaybackManager.c"
					MusicAudioObject* audio_object = NULL;
					GFile* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					MusicAudioObject* _tmp11_;
					MusicAudioObject* _tmp12_;
					gchar* basename = NULL;
					GFile* _tmp13_;
					gchar* _tmp14_;
					const gchar* _tmp15_;
					GstDiscoverer* _tmp22_;
					MusicAudioObject* _tmp23_;
					const gchar* _tmp24_;
					const gchar* _tmp25_;
					GListStore* _tmp26_;
					MusicAudioObject* _tmp27_;
#line 92 "../src/PlaybackManager.vala"
					_tmp8_ = file;
#line 92 "../src/PlaybackManager.vala"
					_tmp9_ = g_file_get_uri (_tmp8_);
#line 92 "../src/PlaybackManager.vala"
					_tmp10_ = _tmp9_;
#line 92 "../src/PlaybackManager.vala"
					_tmp11_ = music_audio_object_new (_tmp10_);
#line 92 "../src/PlaybackManager.vala"
					_tmp12_ = _tmp11_;
#line 92 "../src/PlaybackManager.vala"
					_g_free0 (_tmp10_);
#line 92 "../src/PlaybackManager.vala"
					audio_object = _tmp12_;
#line 94 "../src/PlaybackManager.vala"
					_tmp13_ = file;
#line 94 "../src/PlaybackManager.vala"
					_tmp14_ = g_file_get_basename (_tmp13_);
#line 94 "../src/PlaybackManager.vala"
					basename = _tmp14_;
#line 96 "../src/PlaybackManager.vala"
					_tmp15_ = basename;
#line 96 "../src/PlaybackManager.vala"
					if (_tmp15_ != NULL) {
#line 458 "PlaybackManager.c"
						MusicAudioObject* _tmp16_;
						const gchar* _tmp17_;
#line 97 "../src/PlaybackManager.vala"
						_tmp16_ = audio_object;
#line 97 "../src/PlaybackManager.vala"
						_tmp17_ = basename;
#line 97 "../src/PlaybackManager.vala"
						music_audio_object_set_title (_tmp16_, _tmp17_);
#line 467 "PlaybackManager.c"
					} else {
						MusicAudioObject* _tmp18_;
						MusicAudioObject* _tmp19_;
						const gchar* _tmp20_;
						const gchar* _tmp21_;
#line 99 "../src/PlaybackManager.vala"
						_tmp18_ = audio_object;
#line 99 "../src/PlaybackManager.vala"
						_tmp19_ = audio_object;
#line 99 "../src/PlaybackManager.vala"
						_tmp20_ = music_audio_object_get_uri (_tmp19_);
#line 99 "../src/PlaybackManager.vala"
						_tmp21_ = _tmp20_;
#line 99 "../src/PlaybackManager.vala"
						music_audio_object_set_title (_tmp18_, _tmp21_);
#line 483 "PlaybackManager.c"
					}
#line 102 "../src/PlaybackManager.vala"
					_tmp22_ = self->priv->discoverer;
#line 102 "../src/PlaybackManager.vala"
					_tmp23_ = audio_object;
#line 102 "../src/PlaybackManager.vala"
					_tmp24_ = music_audio_object_get_uri (_tmp23_);
#line 102 "../src/PlaybackManager.vala"
					_tmp25_ = _tmp24_;
#line 102 "../src/PlaybackManager.vala"
					gst_discoverer_discover_uri_async (_tmp22_, _tmp25_);
#line 104 "../src/PlaybackManager.vala"
					_tmp26_ = self->priv->_queue_liststore;
#line 104 "../src/PlaybackManager.vala"
					_tmp27_ = audio_object;
#line 104 "../src/PlaybackManager.vala"
					g_list_store_append (_tmp26_, (GObject*) _tmp27_);
#line 91 "../src/PlaybackManager.vala"
					_g_free0 (basename);
#line 91 "../src/PlaybackManager.vala"
					_g_object_unref0 (audio_object);
#line 505 "PlaybackManager.c"
				} else {
					gint _tmp28_;
#line 106 "../src/PlaybackManager.vala"
					_tmp28_ = invalids;
#line 106 "../src/PlaybackManager.vala"
					invalids = _tmp28_ + 1;
#line 107 "../src/PlaybackManager.vala"
					continue;
#line 514 "PlaybackManager.c"
				}
			}
		}
	}
#line 111 "../src/PlaybackManager.vala"
	if (invalids > 0) {
#line 112 "../src/PlaybackManager.vala"
		g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_INVALIDS_FOUND_SIGNAL], 0, invalids);
#line 523 "PlaybackManager.c"
	}
#line 115 "../src/PlaybackManager.vala"
	_tmp29_ = self->priv->_current_audio;
#line 115 "../src/PlaybackManager.vala"
	if (_tmp29_ == NULL) {
#line 529 "PlaybackManager.c"
		MusicAudioObject* audio_object = NULL;
		GListStore* _tmp30_;
		GObject* _tmp31_;
		MusicAudioObject* _tmp32_;
#line 116 "../src/PlaybackManager.vala"
		_tmp30_ = self->priv->_queue_liststore;
#line 116 "../src/PlaybackManager.vala"
		_tmp31_ = g_list_model_get_object ((GListModel*) _tmp30_, (guint) 0);
#line 116 "../src/PlaybackManager.vala"
		audio_object = G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 117 "../src/PlaybackManager.vala"
		_tmp32_ = audio_object;
#line 117 "../src/PlaybackManager.vala"
		if (_tmp32_ != NULL) {
#line 544 "PlaybackManager.c"
			MusicAudioObject* _tmp33_;
#line 118 "../src/PlaybackManager.vala"
			_tmp33_ = audio_object;
#line 118 "../src/PlaybackManager.vala"
			music_playback_manager_set_current_audio (self, _tmp33_);
#line 550 "PlaybackManager.c"
		}
#line 115 "../src/PlaybackManager.vala"
		_g_object_unref0 (audio_object);
#line 554 "PlaybackManager.c"
	} else {
		GtkApplication* application = NULL;
		GApplication* _tmp34_;
		GtkApplication* _tmp35_;
		gint added_tracks = 0;
		gboolean _tmp36_ = FALSE;
		GtkApplication* _tmp37_;
		GtkWindow* _tmp38_;
		gboolean _tmp39_;
		gboolean _tmp40_;
#line 122 "../src/PlaybackManager.vala"
		_tmp34_ = g_application_get_default ();
#line 122 "../src/PlaybackManager.vala"
		_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_application_get_type (), GtkApplication));
#line 122 "../src/PlaybackManager.vala"
		application = _tmp35_;
#line 123 "../src/PlaybackManager.vala"
		added_tracks = files_length1 - invalids;
#line 125 "../src/PlaybackManager.vala"
		_tmp37_ = application;
#line 125 "../src/PlaybackManager.vala"
		_tmp38_ = gtk_application_get_active_window (_tmp37_);
#line 125 "../src/PlaybackManager.vala"
		g_object_get (_tmp38_, "is-active", &_tmp39_, NULL);
#line 125 "../src/PlaybackManager.vala"
		_tmp40_ = _tmp39_;
#line 125 "../src/PlaybackManager.vala"
		if (!_tmp40_) {
#line 126 "../src/PlaybackManager.vala"
			_tmp36_ = added_tracks > 0;
#line 585 "PlaybackManager.c"
		} else {
#line 125 "../src/PlaybackManager.vala"
			_tmp36_ = FALSE;
#line 589 "PlaybackManager.c"
		}
#line 124 "../src/PlaybackManager.vala"
		if (_tmp36_) {
#line 593 "PlaybackManager.c"
			GNotification* notification = NULL;
			gchar* _tmp41_;
			gchar* _tmp42_;
			GNotification* _tmp43_;
			GNotification* _tmp44_;
			GNotification* _tmp45_;
			GThemedIcon* _tmp46_;
			GThemedIcon* _tmp47_;
			GtkApplication* _tmp48_;
			GNotification* _tmp49_;
#line 128 "../src/PlaybackManager.vala"
			_tmp41_ = g_strdup_printf (ngettext ("%d track was added to the queue", "%d tracks were added to the queue", (gulong) added_tracks), added_tracks);
#line 128 "../src/PlaybackManager.vala"
			_tmp42_ = _tmp41_;
#line 128 "../src/PlaybackManager.vala"
			_tmp43_ = g_notification_new (_tmp42_);
#line 128 "../src/PlaybackManager.vala"
			_tmp44_ = _tmp43_;
#line 128 "../src/PlaybackManager.vala"
			_g_free0 (_tmp42_);
#line 128 "../src/PlaybackManager.vala"
			notification = _tmp44_;
#line 135 "../src/PlaybackManager.vala"
			_tmp45_ = notification;
#line 135 "../src/PlaybackManager.vala"
			_tmp46_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 135 "../src/PlaybackManager.vala"
			_tmp47_ = _tmp46_;
#line 135 "../src/PlaybackManager.vala"
			g_notification_set_icon (_tmp45_, (GIcon*) _tmp47_);
#line 135 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp47_);
#line 137 "../src/PlaybackManager.vala"
			_tmp48_ = application;
#line 137 "../src/PlaybackManager.vala"
			_tmp49_ = notification;
#line 137 "../src/PlaybackManager.vala"
			g_application_send_notification ((GApplication*) _tmp48_, "queue-files", _tmp49_);
#line 124 "../src/PlaybackManager.vala"
			_g_object_unref0 (notification);
#line 634 "PlaybackManager.c"
		}
#line 115 "../src/PlaybackManager.vala"
		_g_object_unref0 (application);
#line 638 "PlaybackManager.c"
	}
}

static gboolean
__lambda5_ (const gchar* a,
            const gchar* b)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 164 "../src/PlaybackManager.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 164 "../src/PlaybackManager.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 165 "../src/PlaybackManager.vala"
	_tmp0_ = music_audio_object_get_uri (G_TYPE_CHECK_INSTANCE_CAST (a, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject));
#line 165 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 165 "../src/PlaybackManager.vala"
	_tmp2_ = music_audio_object_get_uri (G_TYPE_CHECK_INSTANCE_CAST (b, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject));
#line 165 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 165 "../src/PlaybackManager.vala"
	result = g_strcmp0 (_tmp1_, _tmp3_) == 0;
#line 165 "../src/PlaybackManager.vala"
	return result;
#line 667 "PlaybackManager.c"
}

static gboolean
___lambda5__gequal_func (gconstpointer a,
                         gconstpointer b)
{
	gboolean result;
	result = __lambda5_ ((const gchar*) a, (const gchar*) b);
#line 164 "../src/PlaybackManager.vala"
	return result;
#line 678 "PlaybackManager.c"
}

static gpointer
_gst_buffer_ref0 (gpointer self)
{
#line 195 "../src/PlaybackManager.vala"
	return self ? gst_buffer_ref (self) : NULL;
#line 686 "PlaybackManager.c"
}

static void
music_playback_manager_update_metadata (MusicPlaybackManager* self,
                                        GstDiscovererInfo* info,
                                        GError* err)
{
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GEqualFunc equal_func = NULL;
	MusicAudioObject* temp_audio_object = NULL;
	const gchar* _tmp8_;
	MusicAudioObject* _tmp9_;
	guint position = 0U;
	GListStore* _tmp10_;
	MusicAudioObject* _tmp11_;
	GEqualFunc _tmp12_;
	guint _tmp13_ = 0U;
#line 142 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/PlaybackManager.vala"
	g_return_if_fail (info != NULL);
#line 143 "../src/PlaybackManager.vala"
	_tmp0_ = gst_discoverer_info_get_uri (info);
#line 143 "../src/PlaybackManager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 143 "../src/PlaybackManager.vala"
	uri = _tmp1_;
#line 144 "../src/PlaybackManager.vala"
	switch (gst_discoverer_info_get_result (info)) {
#line 144 "../src/PlaybackManager.vala"
		case GST_DISCOVERER_URI_INVALID:
#line 720 "PlaybackManager.c"
		{
			const gchar* _tmp2_;
#line 146 "../src/PlaybackManager.vala"
			_tmp2_ = uri;
#line 146 "../src/PlaybackManager.vala"
			g_critical ("PlaybackManager.vala:146: Couldn't read metadata for '%s': invalid URI" \
".", _tmp2_);
#line 147 "../src/PlaybackManager.vala"
			_g_free0 (uri);
#line 147 "../src/PlaybackManager.vala"
			return;
#line 731 "PlaybackManager.c"
		}
#line 144 "../src/PlaybackManager.vala"
		case GST_DISCOVERER_ERROR:
#line 735 "PlaybackManager.c"
		{
			const gchar* _tmp3_;
			const gchar* _tmp4_;
#line 149 "../src/PlaybackManager.vala"
			_tmp3_ = uri;
#line 149 "../src/PlaybackManager.vala"
			_tmp4_ = err->message;
#line 149 "../src/PlaybackManager.vala"
			g_critical ("PlaybackManager.vala:149: Couldn't read metadata for '%s': %s", _tmp3_, _tmp4_);
#line 150 "../src/PlaybackManager.vala"
			_g_free0 (uri);
#line 150 "../src/PlaybackManager.vala"
			return;
#line 749 "PlaybackManager.c"
		}
#line 144 "../src/PlaybackManager.vala"
		case GST_DISCOVERER_TIMEOUT:
#line 753 "PlaybackManager.c"
		{
			const gchar* _tmp5_;
#line 152 "../src/PlaybackManager.vala"
			_tmp5_ = uri;
#line 152 "../src/PlaybackManager.vala"
			g_critical ("PlaybackManager.vala:152: Couldn't read metadata for '%s': Discovery t" \
"imed out.", _tmp5_);
#line 153 "../src/PlaybackManager.vala"
			_g_free0 (uri);
#line 153 "../src/PlaybackManager.vala"
			return;
#line 764 "PlaybackManager.c"
		}
#line 144 "../src/PlaybackManager.vala"
		case GST_DISCOVERER_BUSY:
#line 768 "PlaybackManager.c"
		{
			const gchar* _tmp6_;
#line 155 "../src/PlaybackManager.vala"
			_tmp6_ = uri;
#line 155 "../src/PlaybackManager.vala"
			g_critical ("PlaybackManager.vala:155: Couldn't read metadata for '%s': Already dis" \
"covering a file.", _tmp6_);
#line 156 "../src/PlaybackManager.vala"
			_g_free0 (uri);
#line 156 "../src/PlaybackManager.vala"
			return;
#line 779 "PlaybackManager.c"
		}
#line 144 "../src/PlaybackManager.vala"
		case GST_DISCOVERER_MISSING_PLUGINS:
#line 783 "PlaybackManager.c"
		{
			const gchar* _tmp7_;
#line 158 "../src/PlaybackManager.vala"
			_tmp7_ = uri;
#line 158 "../src/PlaybackManager.vala"
			g_critical ("PlaybackManager.vala:158: Couldn't read metadata for '%s': Missing plu" \
"gins.", _tmp7_);
#line 159 "../src/PlaybackManager.vala"
			_g_free0 (uri);
#line 159 "../src/PlaybackManager.vala"
			return;
#line 794 "PlaybackManager.c"
		}
		default:
		{
#line 161 "../src/PlaybackManager.vala"
			break;
#line 800 "PlaybackManager.c"
		}
	}
#line 164 "../src/PlaybackManager.vala"
	equal_func = ___lambda5__gequal_func;
#line 168 "../src/PlaybackManager.vala"
	_tmp8_ = uri;
#line 168 "../src/PlaybackManager.vala"
	_tmp9_ = music_audio_object_new (_tmp8_);
#line 168 "../src/PlaybackManager.vala"
	temp_audio_object = _tmp9_;
#line 170 "../src/PlaybackManager.vala"
	position = (guint) -1;
#line 171 "../src/PlaybackManager.vala"
	_tmp10_ = self->priv->_queue_liststore;
#line 171 "../src/PlaybackManager.vala"
	_tmp11_ = temp_audio_object;
#line 171 "../src/PlaybackManager.vala"
	_tmp12_ = equal_func;
#line 171 "../src/PlaybackManager.vala"
	g_list_store_find_with_equal_func (_tmp10_, (GObject*) _tmp11_, _tmp12_, &_tmp13_);
#line 171 "../src/PlaybackManager.vala"
	position = _tmp13_;
#line 173 "../src/PlaybackManager.vala"
	if (position != ((guint) -1)) {
#line 825 "PlaybackManager.c"
		MusicAudioObject* audio_object = NULL;
		GListStore* _tmp14_;
		GObject* _tmp15_;
		MusicAudioObject* _tmp16_;
		GstTagList* tag_list = NULL;
		GstTagList* _tmp17_;
		gchar* _title = NULL;
		GstTagList* _tmp18_;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* _artist = NULL;
		GstTagList* _tmp23_;
		gchar* _tmp24_ = NULL;
		const gchar* _tmp25_;
		GstSample* sample = NULL;
		GstTagList* _tmp30_;
		GstSample* _tmp31_;
		GstSample* _tmp32_;
#line 174 "../src/PlaybackManager.vala"
		_tmp14_ = self->priv->_queue_liststore;
#line 174 "../src/PlaybackManager.vala"
		_tmp15_ = g_list_model_get_item ((GListModel*) _tmp14_, position);
#line 174 "../src/PlaybackManager.vala"
		audio_object = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 175 "../src/PlaybackManager.vala"
		_tmp16_ = audio_object;
#line 175 "../src/PlaybackManager.vala"
		music_audio_object_set_duration (_tmp16_, (gint64) gst_discoverer_info_get_duration (info));
#line 177 "../src/PlaybackManager.vala"
		_tmp17_ = gst_discoverer_info_get_tags (info);
#line 177 "../src/PlaybackManager.vala"
		tag_list = _tmp17_;
#line 180 "../src/PlaybackManager.vala"
		_tmp18_ = tag_list;
#line 180 "../src/PlaybackManager.vala"
		gst_tag_list_get_string (_tmp18_, GST_TAG_TITLE, &_tmp19_);
#line 180 "../src/PlaybackManager.vala"
		_g_free0 (_title);
#line 180 "../src/PlaybackManager.vala"
		_title = _tmp19_;
#line 181 "../src/PlaybackManager.vala"
		_tmp20_ = _title;
#line 181 "../src/PlaybackManager.vala"
		if (_tmp20_ != NULL) {
#line 870 "PlaybackManager.c"
			MusicAudioObject* _tmp21_;
			const gchar* _tmp22_;
#line 182 "../src/PlaybackManager.vala"
			_tmp21_ = audio_object;
#line 182 "../src/PlaybackManager.vala"
			_tmp22_ = _title;
#line 182 "../src/PlaybackManager.vala"
			music_audio_object_set_title (_tmp21_, _tmp22_);
#line 879 "PlaybackManager.c"
		}
#line 186 "../src/PlaybackManager.vala"
		_tmp23_ = tag_list;
#line 186 "../src/PlaybackManager.vala"
		gst_tag_list_get_string (_tmp23_, GST_TAG_ARTIST, &_tmp24_);
#line 186 "../src/PlaybackManager.vala"
		_g_free0 (_artist);
#line 186 "../src/PlaybackManager.vala"
		_artist = _tmp24_;
#line 187 "../src/PlaybackManager.vala"
		_tmp25_ = _artist;
#line 187 "../src/PlaybackManager.vala"
		if (_tmp25_ != NULL) {
#line 893 "PlaybackManager.c"
			MusicAudioObject* _tmp26_;
			const gchar* _tmp27_;
#line 188 "../src/PlaybackManager.vala"
			_tmp26_ = audio_object;
#line 188 "../src/PlaybackManager.vala"
			_tmp27_ = _artist;
#line 188 "../src/PlaybackManager.vala"
			music_audio_object_set_artist (_tmp26_, _tmp27_);
#line 902 "PlaybackManager.c"
		} else {
			const gchar* _tmp28_;
#line 189 "../src/PlaybackManager.vala"
			_tmp28_ = _title;
#line 189 "../src/PlaybackManager.vala"
			if (_tmp28_ != NULL) {
#line 909 "PlaybackManager.c"
				MusicAudioObject* _tmp29_;
#line 190 "../src/PlaybackManager.vala"
				_tmp29_ = audio_object;
#line 190 "../src/PlaybackManager.vala"
				music_audio_object_set_artist (_tmp29_, _ ("Unknown"));
#line 915 "PlaybackManager.c"
			}
		}
#line 193 "../src/PlaybackManager.vala"
		_tmp30_ = tag_list;
#line 193 "../src/PlaybackManager.vala"
		_tmp31_ = music_playback_manager_get_cover_sample (self, _tmp30_);
#line 193 "../src/PlaybackManager.vala"
		sample = _tmp31_;
#line 194 "../src/PlaybackManager.vala"
		_tmp32_ = sample;
#line 194 "../src/PlaybackManager.vala"
		if (_tmp32_ != NULL) {
#line 928 "PlaybackManager.c"
			GstBuffer* buffer = NULL;
			GstSample* _tmp33_;
			GstBuffer* _tmp34_;
			GstBuffer* _tmp35_;
			GstBuffer* _tmp36_;
#line 195 "../src/PlaybackManager.vala"
			_tmp33_ = sample;
#line 195 "../src/PlaybackManager.vala"
			_tmp34_ = gst_sample_get_buffer (_tmp33_);
#line 195 "../src/PlaybackManager.vala"
			_tmp35_ = _gst_buffer_ref0 (_tmp34_);
#line 195 "../src/PlaybackManager.vala"
			buffer = _tmp35_;
#line 197 "../src/PlaybackManager.vala"
			_tmp36_ = buffer;
#line 197 "../src/PlaybackManager.vala"
			if (_tmp36_ != NULL) {
#line 946 "PlaybackManager.c"
				MusicAudioObject* _tmp37_;
				GstBuffer* _tmp38_;
				GdkPixbuf* _tmp39_;
				GdkPixbuf* _tmp40_;
				GdkTexture* _tmp41_;
				GdkTexture* _tmp42_;
#line 198 "../src/PlaybackManager.vala"
				_tmp37_ = audio_object;
#line 198 "../src/PlaybackManager.vala"
				_tmp38_ = buffer;
#line 198 "../src/PlaybackManager.vala"
				_tmp39_ = music_playback_manager_get_pixbuf_from_buffer (self, _tmp38_);
#line 198 "../src/PlaybackManager.vala"
				_tmp40_ = _tmp39_;
#line 198 "../src/PlaybackManager.vala"
				_tmp41_ = gdk_texture_new_for_pixbuf (_tmp40_);
#line 198 "../src/PlaybackManager.vala"
				_tmp42_ = _tmp41_;
#line 198 "../src/PlaybackManager.vala"
				music_audio_object_set_texture (_tmp37_, _tmp42_);
#line 198 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp42_);
#line 198 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp40_);
#line 971 "PlaybackManager.c"
			}
#line 194 "../src/PlaybackManager.vala"
			_gst_buffer_unref0 (buffer);
#line 975 "PlaybackManager.c"
		}
#line 173 "../src/PlaybackManager.vala"
		_gst_sample_unref0 (sample);
#line 173 "../src/PlaybackManager.vala"
		_g_free0 (_artist);
#line 173 "../src/PlaybackManager.vala"
		_g_free0 (_title);
#line 173 "../src/PlaybackManager.vala"
		_g_object_unref0 (audio_object);
#line 985 "PlaybackManager.c"
	} else {
		const gchar* _tmp43_;
#line 202 "../src/PlaybackManager.vala"
		_tmp43_ = uri;
#line 202 "../src/PlaybackManager.vala"
		g_critical ("PlaybackManager.vala:202: Couldn't find '%s' in queue", _tmp43_);
#line 992 "PlaybackManager.c"
	}
#line 142 "../src/PlaybackManager.vala"
	_g_object_unref0 (temp_audio_object);
#line 142 "../src/PlaybackManager.vala"
	_g_free0 (uri);
#line 998 "PlaybackManager.c"
}

static GVariant*
_variant_new2 (gboolean value)
{
#line 234 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1006 "PlaybackManager.c"
}

static gboolean
____lambda6_ (MusicPlaybackManager* self)
{
	gint64 position = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	MusicAudioObject* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gboolean result;
#line 237 "../src/PlaybackManager.vala"
	position = (gint64) 0;
#line 238 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 238 "../src/PlaybackManager.vala"
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 238 "../src/PlaybackManager.vala"
	position = _tmp1_;
#line 239 "../src/PlaybackManager.vala"
	_tmp2_ = self->priv->_current_audio;
#line 239 "../src/PlaybackManager.vala"
	_tmp3_ = music_audio_object_get_duration (_tmp2_);
#line 239 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 239 "../src/PlaybackManager.vala"
	music_playback_manager_set_playback_position (self, CLAMP (position, (gint64) 0, _tmp4_));
#line 241 "../src/PlaybackManager.vala"
	result = G_SOURCE_CONTINUE;
#line 241 "../src/PlaybackManager.vala"
	return result;
#line 1039 "PlaybackManager.c"
}

static gboolean
_____lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda6_ ((MusicPlaybackManager*) self);
#line 236 "../src/PlaybackManager.vala"
	return result;
#line 1049 "PlaybackManager.c"
}

static GVariant*
_variant_new3 (gboolean value)
{
#line 244 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1057 "PlaybackManager.c"
}

static gboolean
music_playback_manager_bus_callback (MusicPlaybackManager* self,
                                     GstBus* bus,
                                     GstMessage* message)
{
	gboolean result;
#line 206 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "../src/PlaybackManager.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 206 "../src/PlaybackManager.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 207 "../src/PlaybackManager.vala"
	switch (message->type) {
#line 207 "../src/PlaybackManager.vala"
		case GST_MESSAGE_EOS:
#line 1076 "PlaybackManager.c"
		{
#line 209 "../src/PlaybackManager.vala"
			music_playback_manager_next (self, TRUE);
#line 210 "../src/PlaybackManager.vala"
			break;
#line 1082 "PlaybackManager.c"
		}
#line 207 "../src/PlaybackManager.vala"
		case GST_MESSAGE_ERROR:
#line 1086 "PlaybackManager.c"
		{
#line 212 "../src/PlaybackManager.vala"
			switch (self->priv->direction) {
#line 212 "../src/PlaybackManager.vala"
				case MUSIC_PLAYBACK_MANAGER_DIRECTION_NEXT:
#line 1092 "PlaybackManager.c"
				{
#line 214 "../src/PlaybackManager.vala"
					music_playback_manager_next (self, self->priv->next_by_eos);
#line 215 "../src/PlaybackManager.vala"
					break;
#line 1098 "PlaybackManager.c"
				}
#line 212 "../src/PlaybackManager.vala"
				case MUSIC_PLAYBACK_MANAGER_DIRECTION_PREVIOUS:
#line 1102 "PlaybackManager.c"
				{
#line 217 "../src/PlaybackManager.vala"
					music_playback_manager_previous (self);
#line 218 "../src/PlaybackManager.vala"
					break;
#line 1108 "PlaybackManager.c"
				}
				default:
				{
#line 220 "../src/PlaybackManager.vala"
					break;
#line 1114 "PlaybackManager.c"
				}
			}
#line 222 "../src/PlaybackManager.vala"
			break;
#line 1119 "PlaybackManager.c"
		}
#line 207 "../src/PlaybackManager.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 1123 "PlaybackManager.c"
		{
			GSimpleAction* play_pause_action = NULL;
			GApplication* _tmp0_;
			GAction* _tmp1_;
			GSimpleAction* _tmp2_;
			GstState old_state = 0;
			GstState new_state = 0;
			GstState pending_state = 0;
			GstState _tmp3_ = 0;
			GstState _tmp4_ = 0;
			GstState _tmp5_ = 0;
#line 224 "../src/PlaybackManager.vala"
			if (self->priv->progress_timer != ((guint) 0)) {
#line 225 "../src/PlaybackManager.vala"
				g_source_remove (self->priv->progress_timer);
#line 226 "../src/PlaybackManager.vala"
				self->priv->progress_timer = (guint) 0;
#line 1141 "PlaybackManager.c"
			}
#line 229 "../src/PlaybackManager.vala"
			_tmp0_ = g_application_get_default ();
#line 229 "../src/PlaybackManager.vala"
			_tmp1_ = g_action_map_lookup_action ((GActionMap*) _tmp0_, MUSIC_APPLICATION_ACTION_PLAY_PAUSE);
#line 229 "../src/PlaybackManager.vala"
			_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 229 "../src/PlaybackManager.vala"
			play_pause_action = _tmp2_;
#line 232 "../src/PlaybackManager.vala"
			gst_message_parse_state_changed (message, &_tmp3_, &_tmp4_, &_tmp5_);
#line 232 "../src/PlaybackManager.vala"
			old_state = _tmp3_;
#line 232 "../src/PlaybackManager.vala"
			new_state = _tmp4_;
#line 232 "../src/PlaybackManager.vala"
			pending_state = _tmp5_;
#line 233 "../src/PlaybackManager.vala"
			if (new_state == GST_STATE_PLAYING) {
#line 1161 "PlaybackManager.c"
				GSimpleAction* _tmp6_;
				GVariant* _tmp7_;
#line 234 "../src/PlaybackManager.vala"
				_tmp6_ = play_pause_action;
#line 234 "../src/PlaybackManager.vala"
				_tmp7_ = _variant_new2 (TRUE);
#line 234 "../src/PlaybackManager.vala"
				g_simple_action_set_state (_tmp6_, _tmp7_);
#line 234 "../src/PlaybackManager.vala"
				_g_variant_unref0 (_tmp7_);
#line 236 "../src/PlaybackManager.vala"
				self->priv->progress_timer = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, _____lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 1174 "PlaybackManager.c"
			} else {
				GSimpleAction* _tmp8_;
				GVariant* _tmp9_;
#line 244 "../src/PlaybackManager.vala"
				_tmp8_ = play_pause_action;
#line 244 "../src/PlaybackManager.vala"
				_tmp9_ = _variant_new3 (FALSE);
#line 244 "../src/PlaybackManager.vala"
				g_simple_action_set_state (_tmp8_, _tmp9_);
#line 244 "../src/PlaybackManager.vala"
				_g_variant_unref0 (_tmp9_);
#line 1186 "PlaybackManager.c"
			}
#line 246 "../src/PlaybackManager.vala"
			_g_object_unref0 (play_pause_action);
#line 246 "../src/PlaybackManager.vala"
			break;
#line 1192 "PlaybackManager.c"
		}
		default:
		{
#line 248 "../src/PlaybackManager.vala"
			break;
#line 1198 "PlaybackManager.c"
		}
	}
#line 251 "../src/PlaybackManager.vala"
	result = TRUE;
#line 251 "../src/PlaybackManager.vala"
	return result;
#line 1205 "PlaybackManager.c"
}

void
music_playback_manager_play_pause (MusicPlaybackManager* self)
{
	GSimpleAction* play_pause_action = NULL;
	GApplication* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gboolean _tmp6_;
#line 254 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/PlaybackManager.vala"
	_tmp0_ = g_application_get_default ();
#line 255 "../src/PlaybackManager.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) _tmp0_, MUSIC_APPLICATION_ACTION_PLAY_PAUSE);
#line 255 "../src/PlaybackManager.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 255 "../src/PlaybackManager.vala"
	play_pause_action = _tmp2_;
#line 256 "../src/PlaybackManager.vala"
	_tmp3_ = play_pause_action;
#line 256 "../src/PlaybackManager.vala"
	_tmp4_ = g_action_get_state ((GAction*) _tmp3_);
#line 256 "../src/PlaybackManager.vala"
	_tmp5_ = _tmp4_;
#line 256 "../src/PlaybackManager.vala"
	_tmp6_ = g_variant_get_boolean (_tmp5_);
#line 256 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp5_);
#line 256 "../src/PlaybackManager.vala"
	if (_tmp6_) {
#line 1241 "PlaybackManager.c"
		GstElement* _tmp7_;
#line 257 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->playbin;
#line 257 "../src/PlaybackManager.vala"
		gst_element_set_state (_tmp7_, GST_STATE_PAUSED);
#line 1247 "PlaybackManager.c"
	} else {
		GstElement* _tmp8_;
#line 259 "../src/PlaybackManager.vala"
		_tmp8_ = self->priv->playbin;
#line 259 "../src/PlaybackManager.vala"
		gst_element_set_state (_tmp8_, GST_STATE_PLAYING);
#line 1254 "PlaybackManager.c"
	}
#line 254 "../src/PlaybackManager.vala"
	_g_object_unref0 (play_pause_action);
#line 1258 "PlaybackManager.c"
}

void
music_playback_manager_next (MusicPlaybackManager* self,
                             gboolean eos)
{
	guint position = 0U;
	GListStore* _tmp0_;
	MusicAudioObject* _tmp1_;
	guint _tmp2_ = 0U;
#line 263 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/PlaybackManager.vala"
	self->priv->direction = MUSIC_PLAYBACK_MANAGER_DIRECTION_NEXT;
#line 265 "../src/PlaybackManager.vala"
	self->priv->next_by_eos = eos;
#line 266 "../src/PlaybackManager.vala"
	position = (guint) -1;
#line 267 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_queue_liststore;
#line 267 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_audio;
#line 267 "../src/PlaybackManager.vala"
	g_list_store_find (_tmp0_, (GObject*) _tmp1_, &_tmp2_);
#line 267 "../src/PlaybackManager.vala"
	position = _tmp2_;
#line 269 "../src/PlaybackManager.vala"
	if (position != ((guint) -1)) {
#line 1287 "PlaybackManager.c"
		GSettings* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GQuark _tmp14_ = 0U;
#line 282 "../src/PlaybackManager.vala"
		static GQuark _tmp13_label0 = 0;
#line 282 "../src/PlaybackManager.vala"
		static GQuark _tmp13_label1 = 0;
#line 282 "../src/PlaybackManager.vala"
		static GQuark _tmp13_label2 = 0;
#line 270 "../src/PlaybackManager.vala"
		if (!self->priv->next_by_eos) {
#line 1300 "PlaybackManager.c"
			GListStore* _tmp3_;
#line 271 "../src/PlaybackManager.vala"
			_tmp3_ = self->priv->_queue_liststore;
#line 271 "../src/PlaybackManager.vala"
			if (position == (g_list_model_get_n_items ((GListModel*) _tmp3_) - 1)) {
#line 1306 "PlaybackManager.c"
				GListStore* _tmp4_;
				GObject* _tmp5_;
				MusicAudioObject* _tmp6_;
#line 272 "../src/PlaybackManager.vala"
				_tmp4_ = self->priv->_queue_liststore;
#line 272 "../src/PlaybackManager.vala"
				_tmp5_ = g_list_model_get_item ((GListModel*) _tmp4_, (guint) 0);
#line 272 "../src/PlaybackManager.vala"
				_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 272 "../src/PlaybackManager.vala"
				music_playback_manager_set_current_audio (self, _tmp6_);
#line 272 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp6_);
#line 273 "../src/PlaybackManager.vala"
				if (position == ((guint) 0)) {
#line 274 "../src/PlaybackManager.vala"
					music_playback_manager_seek_to_progress (self, (gdouble) 0);
#line 1324 "PlaybackManager.c"
				}
			} else {
				GListStore* _tmp7_;
				GObject* _tmp8_;
				MusicAudioObject* _tmp9_;
#line 277 "../src/PlaybackManager.vala"
				_tmp7_ = self->priv->_queue_liststore;
#line 277 "../src/PlaybackManager.vala"
				_tmp8_ = g_list_model_get_item ((GListModel*) _tmp7_, position + 1);
#line 277 "../src/PlaybackManager.vala"
				_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 277 "../src/PlaybackManager.vala"
				music_playback_manager_set_current_audio (self, _tmp9_);
#line 277 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp9_);
#line 1340 "PlaybackManager.c"
			}
#line 280 "../src/PlaybackManager.vala"
			return;
#line 1344 "PlaybackManager.c"
		}
#line 282 "../src/PlaybackManager.vala"
		_tmp10_ = self->priv->settings;
#line 282 "../src/PlaybackManager.vala"
		_tmp11_ = g_settings_get_string (_tmp10_, "repeat-mode");
#line 282 "../src/PlaybackManager.vala"
		_tmp12_ = _tmp11_;
#line 282 "../src/PlaybackManager.vala"
		_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
#line 282 "../src/PlaybackManager.vala"
		g_free (_tmp12_);
#line 282 "../src/PlaybackManager.vala"
		if (_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("disabled")))) {
#line 282 "../src/PlaybackManager.vala"
			switch (0) {
#line 1360 "PlaybackManager.c"
				default:
				{
					GListStore* _tmp15_;
					GListStore* _tmp16_;
					GObject* _tmp17_;
					MusicAudioObject* _tmp18_;
#line 284 "../src/PlaybackManager.vala"
					_tmp15_ = self->priv->_queue_liststore;
#line 284 "../src/PlaybackManager.vala"
					if (position == (g_list_model_get_n_items ((GListModel*) _tmp15_) - 1)) {
#line 285 "../src/PlaybackManager.vala"
						music_playback_manager_set_current_audio (self, NULL);
#line 286 "../src/PlaybackManager.vala"
						return;
#line 1375 "PlaybackManager.c"
					}
#line 289 "../src/PlaybackManager.vala"
					_tmp16_ = self->priv->_queue_liststore;
#line 289 "../src/PlaybackManager.vala"
					_tmp17_ = g_list_model_get_item ((GListModel*) _tmp16_, position + 1);
#line 289 "../src/PlaybackManager.vala"
					_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 289 "../src/PlaybackManager.vala"
					music_playback_manager_set_current_audio (self, _tmp18_);
#line 289 "../src/PlaybackManager.vala"
					_g_object_unref0 (_tmp18_);
#line 291 "../src/PlaybackManager.vala"
					break;
#line 1389 "PlaybackManager.c"
				}
			}
		} else if (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("all")))) {
#line 282 "../src/PlaybackManager.vala"
			switch (0) {
#line 1395 "PlaybackManager.c"
				default:
				{
					GListStore* _tmp19_;
#line 294 "../src/PlaybackManager.vala"
					_tmp19_ = self->priv->_queue_liststore;
#line 294 "../src/PlaybackManager.vala"
					if (position == (g_list_model_get_n_items ((GListModel*) _tmp19_) - 1)) {
#line 1403 "PlaybackManager.c"
						GListStore* _tmp20_;
						GObject* _tmp21_;
						MusicAudioObject* _tmp22_;
#line 295 "../src/PlaybackManager.vala"
						_tmp20_ = self->priv->_queue_liststore;
#line 295 "../src/PlaybackManager.vala"
						_tmp21_ = g_list_model_get_item ((GListModel*) _tmp20_, (guint) 0);
#line 295 "../src/PlaybackManager.vala"
						_tmp22_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 295 "../src/PlaybackManager.vala"
						music_playback_manager_set_current_audio (self, _tmp22_);
#line 295 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp22_);
#line 296 "../src/PlaybackManager.vala"
						if (position == ((guint) 0)) {
#line 297 "../src/PlaybackManager.vala"
							music_playback_manager_seek_to_progress (self, (gdouble) 0);
#line 1421 "PlaybackManager.c"
						}
					} else {
						GListStore* _tmp23_;
						GObject* _tmp24_;
						MusicAudioObject* _tmp25_;
#line 300 "../src/PlaybackManager.vala"
						_tmp23_ = self->priv->_queue_liststore;
#line 300 "../src/PlaybackManager.vala"
						_tmp24_ = g_list_model_get_item ((GListModel*) _tmp23_, position + 1);
#line 300 "../src/PlaybackManager.vala"
						_tmp25_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 300 "../src/PlaybackManager.vala"
						music_playback_manager_set_current_audio (self, _tmp25_);
#line 300 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp25_);
#line 1437 "PlaybackManager.c"
					}
#line 303 "../src/PlaybackManager.vala"
					break;
#line 1441 "PlaybackManager.c"
				}
			}
		} else if (_tmp14_ == ((0 != _tmp13_label2) ? _tmp13_label2 : (_tmp13_label2 = g_quark_from_static_string ("one")))) {
#line 282 "../src/PlaybackManager.vala"
			switch (0) {
#line 1447 "PlaybackManager.c"
				default:
				{
#line 306 "../src/PlaybackManager.vala"
					music_playback_manager_seek_to_progress (self, (gdouble) 0);
#line 307 "../src/PlaybackManager.vala"
					break;
#line 1454 "PlaybackManager.c"
				}
			}
		}
	}
}

void
music_playback_manager_previous (MusicPlaybackManager* self)
{
	guint position = 0U;
	GListStore* _tmp0_;
	MusicAudioObject* _tmp1_;
	guint _tmp2_ = 0U;
	gboolean _tmp3_ = FALSE;
#line 312 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/PlaybackManager.vala"
	self->priv->direction = MUSIC_PLAYBACK_MANAGER_DIRECTION_PREVIOUS;
#line 314 "../src/PlaybackManager.vala"
	position = (guint) -1;
#line 315 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_queue_liststore;
#line 315 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_audio;
#line 315 "../src/PlaybackManager.vala"
	g_list_store_find (_tmp0_, (GObject*) _tmp1_, &_tmp2_);
#line 315 "../src/PlaybackManager.vala"
	position = _tmp2_;
#line 317 "../src/PlaybackManager.vala"
	if (position != ((guint) -1)) {
#line 317 "../src/PlaybackManager.vala"
		_tmp3_ = position != ((guint) 0);
#line 1487 "PlaybackManager.c"
	} else {
#line 317 "../src/PlaybackManager.vala"
		_tmp3_ = FALSE;
#line 1491 "PlaybackManager.c"
	}
#line 317 "../src/PlaybackManager.vala"
	if (_tmp3_) {
#line 1495 "PlaybackManager.c"
		GListStore* _tmp4_;
		GObject* _tmp5_;
		MusicAudioObject* _tmp6_;
#line 318 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_queue_liststore;
#line 318 "../src/PlaybackManager.vala"
		_tmp5_ = g_list_model_get_item ((GListModel*) _tmp4_, position - 1);
#line 318 "../src/PlaybackManager.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 318 "../src/PlaybackManager.vala"
		music_playback_manager_set_current_audio (self, _tmp6_);
#line 318 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp6_);
#line 1509 "PlaybackManager.c"
	}
#line 321 "../src/PlaybackManager.vala"
	if (position == ((guint) 0)) {
#line 1513 "PlaybackManager.c"
		guint n_items = 0U;
		GListStore* _tmp7_;
#line 322 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_queue_liststore;
#line 322 "../src/PlaybackManager.vala"
		n_items = g_list_model_get_n_items ((GListModel*) _tmp7_);
#line 323 "../src/PlaybackManager.vala"
		if (n_items == ((guint) 1)) {
#line 324 "../src/PlaybackManager.vala"
			music_playback_manager_seek_to_progress (self, (gdouble) 0);
#line 1524 "PlaybackManager.c"
		} else {
			GListStore* _tmp8_;
			GObject* _tmp9_;
			MusicAudioObject* _tmp10_;
#line 326 "../src/PlaybackManager.vala"
			_tmp8_ = self->priv->_queue_liststore;
#line 326 "../src/PlaybackManager.vala"
			_tmp9_ = g_list_model_get_item ((GListModel*) _tmp8_, n_items - 1);
#line 326 "../src/PlaybackManager.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, MUSIC_TYPE_AUDIO_OBJECT, MusicAudioObject);
#line 326 "../src/PlaybackManager.vala"
			music_playback_manager_set_current_audio (self, _tmp10_);
#line 326 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp10_);
#line 1539 "PlaybackManager.c"
		}
	}
}

void
music_playback_manager_shuffle (MusicPlaybackManager* self)
{
	GListStore* temp_list = NULL;
	GListStore* _tmp0_;
	GListStore* _tmp1_;
	MusicAudioObject* _tmp2_;
	guint position = 0U;
	GListStore* _tmp3_;
	MusicAudioObject* _tmp4_;
	guint _tmp5_ = 0U;
	GListStore* _tmp6_;
#line 331 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/PlaybackManager.vala"
	_tmp0_ = g_list_store_new (MUSIC_TYPE_AUDIO_OBJECT);
#line 332 "../src/PlaybackManager.vala"
	temp_list = _tmp0_;
#line 333 "../src/PlaybackManager.vala"
	_tmp1_ = temp_list;
#line 333 "../src/PlaybackManager.vala"
	_tmp2_ = self->priv->_current_audio;
#line 333 "../src/PlaybackManager.vala"
	g_list_store_append (_tmp1_, (GObject*) _tmp2_);
#line 335 "../src/PlaybackManager.vala"
	position = (guint) -1;
#line 336 "../src/PlaybackManager.vala"
	_tmp3_ = self->priv->_queue_liststore;
#line 336 "../src/PlaybackManager.vala"
	_tmp4_ = self->priv->_current_audio;
#line 336 "../src/PlaybackManager.vala"
	g_list_store_find (_tmp3_, (GObject*) _tmp4_, &_tmp5_);
#line 336 "../src/PlaybackManager.vala"
	position = _tmp5_;
#line 337 "../src/PlaybackManager.vala"
	_tmp6_ = self->priv->_queue_liststore;
#line 337 "../src/PlaybackManager.vala"
	g_list_store_remove (_tmp6_, position);
#line 339 "../src/PlaybackManager.vala"
	while (TRUE) {
#line 1584 "PlaybackManager.c"
		GListStore* _tmp7_;
		gint32 random_position = 0;
		GListStore* _tmp8_;
		GListStore* _tmp9_;
		GListStore* _tmp10_;
		GObject* _tmp11_;
		GObject* _tmp12_;
		GListStore* _tmp13_;
#line 339 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_queue_liststore;
#line 339 "../src/PlaybackManager.vala"
		if (!(g_list_model_get_n_items ((GListModel*) _tmp7_) > ((guint) 0))) {
#line 339 "../src/PlaybackManager.vala"
			break;
#line 1599 "PlaybackManager.c"
		}
#line 340 "../src/PlaybackManager.vala"
		_tmp8_ = self->priv->_queue_liststore;
#line 340 "../src/PlaybackManager.vala"
		random_position = g_random_int_range ((gint32) 0, (gint32) g_list_model_get_n_items ((GListModel*) _tmp8_));
#line 342 "../src/PlaybackManager.vala"
		_tmp9_ = temp_list;
#line 342 "../src/PlaybackManager.vala"
		_tmp10_ = self->priv->_queue_liststore;
#line 342 "../src/PlaybackManager.vala"
		_tmp11_ = g_list_model_get_item ((GListModel*) _tmp10_, (guint) random_position);
#line 342 "../src/PlaybackManager.vala"
		_tmp12_ = _tmp11_;
#line 342 "../src/PlaybackManager.vala"
		g_list_store_append (_tmp9_, _tmp12_);
#line 342 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp12_);
#line 343 "../src/PlaybackManager.vala"
		_tmp13_ = self->priv->_queue_liststore;
#line 343 "../src/PlaybackManager.vala"
		g_list_store_remove (_tmp13_, (guint) random_position);
#line 1621 "PlaybackManager.c"
	}
	{
		gint i = 0;
#line 346 "../src/PlaybackManager.vala"
		i = 0;
#line 1627 "PlaybackManager.c"
		{
			gboolean _tmp14_ = FALSE;
#line 346 "../src/PlaybackManager.vala"
			_tmp14_ = TRUE;
#line 346 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 1634 "PlaybackManager.c"
				GListStore* _tmp16_;
				GListStore* _tmp17_;
				GListStore* _tmp18_;
				GObject* _tmp19_;
				GObject* _tmp20_;
#line 346 "../src/PlaybackManager.vala"
				if (!_tmp14_) {
#line 1642 "PlaybackManager.c"
					gint _tmp15_;
#line 346 "../src/PlaybackManager.vala"
					_tmp15_ = i;
#line 346 "../src/PlaybackManager.vala"
					i = _tmp15_ + 1;
#line 1648 "PlaybackManager.c"
				}
#line 346 "../src/PlaybackManager.vala"
				_tmp14_ = FALSE;
#line 346 "../src/PlaybackManager.vala"
				_tmp16_ = temp_list;
#line 346 "../src/PlaybackManager.vala"
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp16_))) {
#line 346 "../src/PlaybackManager.vala"
					break;
#line 1658 "PlaybackManager.c"
				}
#line 347 "../src/PlaybackManager.vala"
				_tmp17_ = self->priv->_queue_liststore;
#line 347 "../src/PlaybackManager.vala"
				_tmp18_ = temp_list;
#line 347 "../src/PlaybackManager.vala"
				_tmp19_ = g_list_model_get_item ((GListModel*) _tmp18_, (guint) i);
#line 347 "../src/PlaybackManager.vala"
				_tmp20_ = _tmp19_;
#line 347 "../src/PlaybackManager.vala"
				g_list_store_append (_tmp17_, _tmp20_);
#line 347 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp20_);
#line 1672 "PlaybackManager.c"
			}
		}
	}
#line 331 "../src/PlaybackManager.vala"
	_g_object_unref0 (temp_list);
#line 1678 "PlaybackManager.c"
}

static void
music_playback_manager_update_next_previous_sensitivity (MusicPlaybackManager* self)
{
	gboolean next_sensitive = FALSE;
	gboolean previous_sensitive = FALSE;
	MusicAudioObject* _tmp0_;
	GApplication* default_application = NULL;
	GApplication* _tmp1_;
	GApplication* _tmp2_;
	GSimpleAction* next_action = NULL;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* previous_action = NULL;
	GAction* _tmp5_;
	GSimpleAction* _tmp6_;
#line 351 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/PlaybackManager.vala"
	next_sensitive = FALSE;
#line 353 "../src/PlaybackManager.vala"
	previous_sensitive = FALSE;
#line 355 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_audio;
#line 355 "../src/PlaybackManager.vala"
	previous_sensitive = _tmp0_ != NULL;
#line 355 "../src/PlaybackManager.vala"
	next_sensitive = previous_sensitive;
#line 357 "../src/PlaybackManager.vala"
	_tmp1_ = g_application_get_default ();
#line 357 "../src/PlaybackManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 357 "../src/PlaybackManager.vala"
	default_application = _tmp2_;
#line 359 "../src/PlaybackManager.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) default_application, MUSIC_APPLICATION_ACTION_NEXT);
#line 359 "../src/PlaybackManager.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction));
#line 359 "../src/PlaybackManager.vala"
	next_action = _tmp4_;
#line 360 "../src/PlaybackManager.vala"
	g_simple_action_set_enabled (next_action, next_sensitive);
#line 362 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) default_application, MUSIC_APPLICATION_ACTION_PREVIOUS);
#line 362 "../src/PlaybackManager.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction));
#line 362 "../src/PlaybackManager.vala"
	previous_action = _tmp6_;
#line 363 "../src/PlaybackManager.vala"
	g_simple_action_set_enabled (previous_action, previous_sensitive);
#line 351 "../src/PlaybackManager.vala"
	_g_object_unref0 (previous_action);
#line 351 "../src/PlaybackManager.vala"
	_g_object_unref0 (next_action);
#line 351 "../src/PlaybackManager.vala"
	_g_object_unref0 (default_application);
#line 1736 "PlaybackManager.c"
}

static gpointer
_gst_caps_ref0 (gpointer self)
{
#line 371 "../src/PlaybackManager.vala"
	return self ? gst_caps_ref (self) : NULL;
#line 1744 "PlaybackManager.c"
}

static gpointer
_gst_sample_ref0 (gpointer self)
{
#line 376 "../src/PlaybackManager.vala"
	return self ? gst_sample_ref (self) : NULL;
#line 1752 "PlaybackManager.c"
}

static GstSample*
music_playback_manager_get_cover_sample (MusicPlaybackManager* self,
                                         GstTagList* tag_list)
{
	GstSample* cover_sample = NULL;
	GstSample* sample = NULL;
	GstSample* result;
#line 367 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "../src/PlaybackManager.vala"
	g_return_val_if_fail (tag_list != NULL, NULL);
#line 368 "../src/PlaybackManager.vala"
	cover_sample = NULL;
#line 1768 "PlaybackManager.c"
	{
		gint i = 0;
#line 370 "../src/PlaybackManager.vala"
		i = 0;
#line 1773 "PlaybackManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 370 "../src/PlaybackManager.vala"
			_tmp0_ = TRUE;
#line 370 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 1780 "PlaybackManager.c"
				GstSample* _tmp2_ = NULL;
				gboolean _tmp3_;
				GstCaps* caps = NULL;
				GstSample* _tmp4_;
				GstCaps* _tmp5_;
				GstCaps* _tmp6_;
				GstStructure* caps_struct = NULL;
				GstCaps* _tmp7_;
				GstStructure* _tmp8_;
				gint image_type = 0;
				GstStructure* _tmp9_;
				gint _tmp10_ = 0;
				gboolean _tmp11_ = FALSE;
#line 370 "../src/PlaybackManager.vala"
				if (!_tmp0_) {
#line 1796 "PlaybackManager.c"
					gint _tmp1_;
#line 370 "../src/PlaybackManager.vala"
					_tmp1_ = i;
#line 370 "../src/PlaybackManager.vala"
					i = _tmp1_ + 1;
#line 1802 "PlaybackManager.c"
				}
#line 370 "../src/PlaybackManager.vala"
				_tmp0_ = FALSE;
#line 370 "../src/PlaybackManager.vala"
				_tmp3_ = gst_tag_list_get_sample_index (tag_list, GST_TAG_IMAGE, (guint) i, &_tmp2_);
#line 370 "../src/PlaybackManager.vala"
				_gst_sample_unref0 (sample);
#line 370 "../src/PlaybackManager.vala"
				sample = _tmp2_;
#line 370 "../src/PlaybackManager.vala"
				if (!_tmp3_) {
#line 370 "../src/PlaybackManager.vala"
					break;
#line 1816 "PlaybackManager.c"
				}
#line 371 "../src/PlaybackManager.vala"
				_tmp4_ = sample;
#line 371 "../src/PlaybackManager.vala"
				_tmp5_ = gst_sample_get_caps (_tmp4_);
#line 371 "../src/PlaybackManager.vala"
				_tmp6_ = _gst_caps_ref0 (_tmp5_);
#line 371 "../src/PlaybackManager.vala"
				caps = _tmp6_;
#line 372 "../src/PlaybackManager.vala"
				_tmp7_ = caps;
#line 372 "../src/PlaybackManager.vala"
				_tmp8_ = gst_caps_get_structure (_tmp7_, (guint) 0);
#line 372 "../src/PlaybackManager.vala"
				caps_struct = _tmp8_;
#line 373 "../src/PlaybackManager.vala"
				image_type = (gint) GST_TAG_IMAGE_TYPE_UNDEFINED;
#line 374 "../src/PlaybackManager.vala"
				_tmp9_ = caps_struct;
#line 374 "../src/PlaybackManager.vala"
				gst_structure_get_enum (_tmp9_, "image-type", gst_tag_image_type_get_type (), &_tmp10_);
#line 374 "../src/PlaybackManager.vala"
				image_type = _tmp10_;
#line 375 "../src/PlaybackManager.vala"
				if (image_type == ((gint) GST_TAG_IMAGE_TYPE_UNDEFINED)) {
#line 1842 "PlaybackManager.c"
					GstSample* _tmp12_;
#line 375 "../src/PlaybackManager.vala"
					_tmp12_ = cover_sample;
#line 375 "../src/PlaybackManager.vala"
					_tmp11_ = _tmp12_ == NULL;
#line 1848 "PlaybackManager.c"
				} else {
#line 375 "../src/PlaybackManager.vala"
					_tmp11_ = FALSE;
#line 1852 "PlaybackManager.c"
				}
#line 375 "../src/PlaybackManager.vala"
				if (_tmp11_) {
#line 1856 "PlaybackManager.c"
					GstSample* _tmp13_;
					GstSample* _tmp14_;
#line 376 "../src/PlaybackManager.vala"
					_tmp13_ = sample;
#line 376 "../src/PlaybackManager.vala"
					_tmp14_ = _gst_sample_ref0 (_tmp13_);
#line 376 "../src/PlaybackManager.vala"
					_gst_sample_unref0 (cover_sample);
#line 376 "../src/PlaybackManager.vala"
					cover_sample = _tmp14_;
#line 1867 "PlaybackManager.c"
				} else {
#line 377 "../src/PlaybackManager.vala"
					if (image_type == ((gint) GST_TAG_IMAGE_TYPE_FRONT_COVER)) {
#line 378 "../src/PlaybackManager.vala"
						result = sample;
#line 378 "../src/PlaybackManager.vala"
						_gst_caps_unref0 (caps);
#line 378 "../src/PlaybackManager.vala"
						_gst_sample_unref0 (cover_sample);
#line 378 "../src/PlaybackManager.vala"
						return result;
#line 1879 "PlaybackManager.c"
					}
				}
#line 370 "../src/PlaybackManager.vala"
				_gst_caps_unref0 (caps);
#line 1884 "PlaybackManager.c"
			}
		}
	}
#line 382 "../src/PlaybackManager.vala"
	result = cover_sample;
#line 382 "../src/PlaybackManager.vala"
	_gst_sample_unref0 (sample);
#line 382 "../src/PlaybackManager.vala"
	return result;
#line 1894 "PlaybackManager.c"
}

static GdkPixbuf*
music_playback_manager_get_pixbuf_from_buffer (MusicPlaybackManager* self,
                                               GstBuffer* buffer)
{
	GstMapInfo map_info = {0};
	GstMapInfo _tmp0_ = {0};
	gboolean _tmp1_;
	GdkPixbuf* pix = NULL;
	GstMapInfo _tmp15_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 385 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 385 "../src/PlaybackManager.vala"
	g_return_val_if_fail (buffer != NULL, NULL);
#line 388 "../src/PlaybackManager.vala"
	_tmp1_ = gst_buffer_map (buffer, &_tmp0_, GST_MAP_READ);
#line 388 "../src/PlaybackManager.vala"
	map_info = _tmp0_;
#line 388 "../src/PlaybackManager.vala"
	if (!_tmp1_) {
#line 389 "../src/PlaybackManager.vala"
		g_warning ("PlaybackManager.vala:389: Could not map memory buffer");
#line 390 "../src/PlaybackManager.vala"
		result = NULL;
#line 390 "../src/PlaybackManager.vala"
		return result;
#line 1924 "PlaybackManager.c"
	}
#line 393 "../src/PlaybackManager.vala"
	pix = NULL;
#line 1928 "PlaybackManager.c"
	{
		GdkPixbufLoader* loader = NULL;
		GdkPixbufLoader* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		GdkPixbufLoader* _tmp5_;
		GstMapInfo _tmp6_;
		guint8* _tmp7_;
		gint _tmp7__length1;
#line 396 "../src/PlaybackManager.vala"
		_tmp2_ = gdk_pixbuf_loader_new ();
#line 396 "../src/PlaybackManager.vala"
		loader = _tmp2_;
#line 398 "../src/PlaybackManager.vala"
		_tmp5_ = loader;
#line 398 "../src/PlaybackManager.vala"
		_tmp6_ = map_info;
#line 398 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_.data;
#line 398 "../src/PlaybackManager.vala"
		_tmp7__length1 = _tmp6_.size;
#line 398 "../src/PlaybackManager.vala"
		_tmp4_ = gdk_pixbuf_loader_write (_tmp5_, _tmp7_, (gsize) _tmp7__length1, &_inner_error0_);
#line 398 "../src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 398 "../src/PlaybackManager.vala"
			_g_object_unref0 (loader);
#line 1956 "PlaybackManager.c"
			goto __catch0_g_error;
		}
#line 398 "../src/PlaybackManager.vala"
		if (_tmp4_) {
#line 1961 "PlaybackManager.c"
			gboolean _tmp8_ = FALSE;
			GdkPixbufLoader* _tmp9_;
#line 398 "../src/PlaybackManager.vala"
			_tmp9_ = loader;
#line 398 "../src/PlaybackManager.vala"
			_tmp8_ = gdk_pixbuf_loader_close (_tmp9_, &_inner_error0_);
#line 398 "../src/PlaybackManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 398 "../src/PlaybackManager.vala"
				_g_object_unref0 (loader);
#line 1972 "PlaybackManager.c"
				goto __catch0_g_error;
			}
#line 398 "../src/PlaybackManager.vala"
			_tmp3_ = _tmp8_;
#line 1977 "PlaybackManager.c"
		} else {
#line 398 "../src/PlaybackManager.vala"
			_tmp3_ = FALSE;
#line 1981 "PlaybackManager.c"
		}
#line 398 "../src/PlaybackManager.vala"
		if (_tmp3_) {
#line 1985 "PlaybackManager.c"
			GdkPixbufLoader* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
#line 399 "../src/PlaybackManager.vala"
			_tmp10_ = loader;
#line 399 "../src/PlaybackManager.vala"
			_tmp11_ = gdk_pixbuf_loader_get_pixbuf (_tmp10_);
#line 399 "../src/PlaybackManager.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 399 "../src/PlaybackManager.vala"
			_g_object_unref0 (pix);
#line 399 "../src/PlaybackManager.vala"
			pix = _tmp12_;
#line 1999 "PlaybackManager.c"
		}
#line 395 "../src/PlaybackManager.vala"
		_g_object_unref0 (loader);
#line 2003 "PlaybackManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 395 "../src/PlaybackManager.vala"
		err = _inner_error0_;
#line 395 "../src/PlaybackManager.vala"
		_inner_error0_ = NULL;
#line 402 "../src/PlaybackManager.vala"
		_tmp13_ = err;
#line 402 "../src/PlaybackManager.vala"
		_tmp14_ = _tmp13_->message;
#line 402 "../src/PlaybackManager.vala"
		g_warning ("PlaybackManager.vala:402: Error processing image data: %s", _tmp14_);
#line 395 "../src/PlaybackManager.vala"
		_g_error_free0 (err);
#line 2023 "PlaybackManager.c"
	}
	__finally0:
#line 395 "../src/PlaybackManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 395 "../src/PlaybackManager.vala"
		_g_object_unref0 (pix);
#line 395 "../src/PlaybackManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 395 "../src/PlaybackManager.vala"
		g_clear_error (&_inner_error0_);
#line 395 "../src/PlaybackManager.vala"
		return NULL;
#line 2036 "PlaybackManager.c"
	}
#line 405 "../src/PlaybackManager.vala"
	_tmp15_ = map_info;
#line 405 "../src/PlaybackManager.vala"
	gst_buffer_unmap (buffer, &_tmp15_);
#line 407 "../src/PlaybackManager.vala"
	result = pix;
#line 407 "../src/PlaybackManager.vala"
	return result;
#line 2046 "PlaybackManager.c"
}

MusicAudioObject*
music_playback_manager_get_current_audio (MusicPlaybackManager* self)
{
	MusicAudioObject* result;
	MusicAudioObject* _tmp0_;
#line 7 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_audio;
#line 7 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 7 "../src/PlaybackManager.vala"
	return result;
#line 2062 "PlaybackManager.c"
}

void
music_playback_manager_set_current_audio (MusicPlaybackManager* self,
                                          MusicAudioObject* value)
{
	MusicAudioObject* old_value;
#line 7 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/PlaybackManager.vala"
	old_value = music_playback_manager_get_current_audio (self);
#line 7 "../src/PlaybackManager.vala"
	if (old_value != value) {
#line 2076 "PlaybackManager.c"
		MusicAudioObject* _tmp0_;
#line 7 "../src/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 7 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_current_audio);
#line 7 "../src/PlaybackManager.vala"
		self->priv->_current_audio = _tmp0_;
#line 7 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_AUDIO_PROPERTY]);
#line 2086 "PlaybackManager.c"
	}
}

GListStore*
music_playback_manager_get_queue_liststore (MusicPlaybackManager* self)
{
	GListStore* result;
	GListStore* _tmp0_;
#line 8 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_queue_liststore;
#line 8 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 8 "../src/PlaybackManager.vala"
	return result;
#line 2103 "PlaybackManager.c"
}

static void
music_playback_manager_set_queue_liststore (MusicPlaybackManager* self,
                                            GListStore* value)
{
	GListStore* old_value;
#line 8 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/PlaybackManager.vala"
	old_value = music_playback_manager_get_queue_liststore (self);
#line 8 "../src/PlaybackManager.vala"
	if (old_value != value) {
#line 2117 "PlaybackManager.c"
		GListStore* _tmp0_;
#line 8 "../src/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 8 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_queue_liststore);
#line 8 "../src/PlaybackManager.vala"
		self->priv->_queue_liststore = _tmp0_;
#line 8 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_QUEUE_LISTSTORE_PROPERTY]);
#line 2127 "PlaybackManager.c"
	}
}

gint64
music_playback_manager_get_playback_position (MusicPlaybackManager* self)
{
	gint64 result;
#line 9 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 9 "../src/PlaybackManager.vala"
	result = self->priv->_playback_position;
#line 9 "../src/PlaybackManager.vala"
	return result;
#line 2141 "PlaybackManager.c"
}

static void
music_playback_manager_set_playback_position (MusicPlaybackManager* self,
                                              gint64 value)
{
	gint64 old_value;
#line 9 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/PlaybackManager.vala"
	old_value = music_playback_manager_get_playback_position (self);
#line 9 "../src/PlaybackManager.vala"
	if (old_value != value) {
#line 9 "../src/PlaybackManager.vala"
		self->priv->_playback_position = value;
#line 9 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYBACK_POSITION_PROPERTY]);
#line 2159 "PlaybackManager.c"
	}
}

static gboolean
_music_playback_manager_bus_callback_gst_bus_func (GstBus* bus,
                                                   GstMessage* message,
                                                   gpointer self)
{
	gboolean result;
	result = music_playback_manager_bus_callback ((MusicPlaybackManager*) self, bus, message);
#line 40 "../src/PlaybackManager.vala"
	return result;
#line 2172 "PlaybackManager.c"
}

static void
_music_playback_manager_update_metadata_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                   GstDiscovererInfo* info,
                                                                   GError* err,
                                                                   gpointer self)
{
#line 45 "../src/PlaybackManager.vala"
	music_playback_manager_update_metadata ((MusicPlaybackManager*) self, info, err);
#line 2183 "PlaybackManager.c"
}

static void
_gst_discoverer_stop_gst_discoverer_finished (GstDiscoverer* _sender,
                                              gpointer self)
{
#line 46 "../src/PlaybackManager.vala"
	gst_discoverer_stop ((GstDiscoverer*) self);
#line 2192 "PlaybackManager.c"
}

static void
_music_playback_manager___lambda7_ (MusicPlaybackManager* self)
{
	GSimpleAction* shuffle_action_action = NULL;
	GApplication* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GListStore* _tmp4_;
#line 52 "../src/PlaybackManager.vala"
	_tmp0_ = g_application_get_default ();
#line 52 "../src/PlaybackManager.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) _tmp0_, MUSIC_APPLICATION_ACTION_SHUFFLE);
#line 52 "../src/PlaybackManager.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 52 "../src/PlaybackManager.vala"
	shuffle_action_action = _tmp2_;
#line 53 "../src/PlaybackManager.vala"
	_tmp3_ = shuffle_action_action;
#line 53 "../src/PlaybackManager.vala"
	_tmp4_ = self->priv->_queue_liststore;
#line 53 "../src/PlaybackManager.vala"
	g_simple_action_set_enabled (_tmp3_, g_list_model_get_n_items ((GListModel*) _tmp4_) > ((guint) 1));
#line 55 "../src/PlaybackManager.vala"
	music_playback_manager_update_next_previous_sensitivity (self);
#line 51 "../src/PlaybackManager.vala"
	_g_object_unref0 (shuffle_action_action);
#line 2222 "PlaybackManager.c"
}

static void
__music_playback_manager___lambda7__g_list_model_items_changed (GListModel* _sender,
                                                                guint position,
                                                                guint removed,
                                                                guint added,
                                                                gpointer self)
{
#line 51 "../src/PlaybackManager.vala"
	_music_playback_manager___lambda7_ ((MusicPlaybackManager*) self);
#line 2234 "PlaybackManager.c"
}

static void
_music_playback_manager___lambda8_ (MusicPlaybackManager* self)
{
	GstElement* _tmp0_;
	MusicAudioObject* _tmp1_;
	GSimpleAction* play_pause_action = NULL;
	GApplication* _tmp8_;
	GAction* _tmp9_;
	GSimpleAction* _tmp10_;
	GSimpleAction* _tmp11_;
	MusicAudioObject* _tmp12_;
#line 59 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 59 "../src/PlaybackManager.vala"
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
#line 60 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_audio;
#line 60 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 2256 "PlaybackManager.c"
		GstElement* _tmp2_;
		MusicAudioObject* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GstElement* _tmp6_;
#line 61 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->playbin;
#line 61 "../src/PlaybackManager.vala"
		_tmp3_ = self->priv->_current_audio;
#line 61 "../src/PlaybackManager.vala"
		_tmp4_ = music_audio_object_get_uri (_tmp3_);
#line 61 "../src/PlaybackManager.vala"
		_tmp5_ = _tmp4_;
#line 61 "../src/PlaybackManager.vala"
		g_object_set (_tmp2_, "uri", _tmp5_, NULL);
#line 62 "../src/PlaybackManager.vala"
		_tmp6_ = self->priv->playbin;
#line 62 "../src/PlaybackManager.vala"
		gst_element_set_state (_tmp6_, GST_STATE_PLAYING);
#line 2276 "PlaybackManager.c"
	} else {
		GstElement* _tmp7_;
#line 64 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->playbin;
#line 64 "../src/PlaybackManager.vala"
		g_object_set (_tmp7_, "uri", "", NULL);
#line 65 "../src/PlaybackManager.vala"
		music_playback_manager_set_playback_position (self, (gint64) 0);
#line 67 "../src/PlaybackManager.vala"
		if (self->priv->progress_timer != ((guint) 0)) {
#line 68 "../src/PlaybackManager.vala"
			g_source_remove (self->priv->progress_timer);
#line 69 "../src/PlaybackManager.vala"
			self->priv->progress_timer = (guint) 0;
#line 2291 "PlaybackManager.c"
		}
	}
#line 73 "../src/PlaybackManager.vala"
	music_playback_manager_update_next_previous_sensitivity (self);
#line 75 "../src/PlaybackManager.vala"
	_tmp8_ = g_application_get_default ();
#line 75 "../src/PlaybackManager.vala"
	_tmp9_ = g_action_map_lookup_action ((GActionMap*) _tmp8_, MUSIC_APPLICATION_ACTION_PLAY_PAUSE);
#line 75 "../src/PlaybackManager.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_simple_action_get_type (), GSimpleAction));
#line 75 "../src/PlaybackManager.vala"
	play_pause_action = _tmp10_;
#line 76 "../src/PlaybackManager.vala"
	_tmp11_ = play_pause_action;
#line 76 "../src/PlaybackManager.vala"
	_tmp12_ = self->priv->_current_audio;
#line 76 "../src/PlaybackManager.vala"
	g_simple_action_set_enabled (_tmp11_, _tmp12_ != NULL);
#line 58 "../src/PlaybackManager.vala"
	_g_object_unref0 (play_pause_action);
#line 2312 "PlaybackManager.c"
}

static void
__music_playback_manager___lambda8__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 58 "../src/PlaybackManager.vala"
	_music_playback_manager___lambda8_ ((MusicPlaybackManager*) self);
#line 2322 "PlaybackManager.c"
}

static GObject *
music_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlaybackManager * self;
	GListStore* _tmp0_;
	GListStore* _tmp1_;
	GstElement* _tmp2_;
	GstBus* bus = NULL;
	GstElement* _tmp3_;
	GstBus* _tmp4_;
	GstBus* _tmp5_;
	GstBus* _tmp6_;
	GListStore* _tmp15_;
	GSettings* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 34 "../src/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (music_playback_manager_parent_class);
#line 34 "../src/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	_tmp0_ = g_list_store_new (MUSIC_TYPE_AUDIO_OBJECT);
#line 35 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/PlaybackManager.vala"
	music_playback_manager_set_queue_liststore (self, _tmp1_);
#line 35 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 37 "../src/PlaybackManager.vala"
	_tmp2_ = gst_element_factory_make ("playbin", "playbin");
#line 37 "../src/PlaybackManager.vala"
	if (_tmp2_ != NULL) {
#line 37 "../src/PlaybackManager.vala"
		g_object_ref_sink (_tmp2_);
#line 2364 "PlaybackManager.c"
	}
#line 37 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbin);
#line 37 "../src/PlaybackManager.vala"
	self->priv->playbin = _tmp2_;
#line 39 "../src/PlaybackManager.vala"
	_tmp3_ = self->priv->playbin;
#line 39 "../src/PlaybackManager.vala"
	_tmp4_ = gst_element_get_bus (_tmp3_);
#line 39 "../src/PlaybackManager.vala"
	bus = _tmp4_;
#line 40 "../src/PlaybackManager.vala"
	_tmp5_ = bus;
#line 40 "../src/PlaybackManager.vala"
	gst_bus_add_watch_full (_tmp5_, 0, _music_playback_manager_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 41 "../src/PlaybackManager.vala"
	_tmp6_ = bus;
#line 41 "../src/PlaybackManager.vala"
	gst_bus_enable_sync_message_emission (_tmp6_);
#line 2384 "PlaybackManager.c"
	{
		GstDiscoverer* _tmp7_ = NULL;
		GstDiscoverer* _tmp8_;
		GstDiscoverer* _tmp9_;
		GstDiscoverer* _tmp10_;
		GstDiscoverer* _tmp11_;
		GstDiscoverer* _tmp12_;
#line 44 "../src/PlaybackManager.vala"
		_tmp8_ = gst_discoverer_new ((GstClockTime) (5 * GST_SECOND), &_inner_error0_);
#line 44 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp8_;
#line 44 "../src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2398 "PlaybackManager.c"
			goto __catch0_g_error;
		}
#line 44 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp7_;
#line 44 "../src/PlaybackManager.vala"
		_tmp7_ = NULL;
#line 44 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->discoverer);
#line 44 "../src/PlaybackManager.vala"
		self->priv->discoverer = _tmp9_;
#line 45 "../src/PlaybackManager.vala"
		_tmp10_ = self->priv->discoverer;
#line 45 "../src/PlaybackManager.vala"
		g_signal_connect_object (_tmp10_, "discovered", (GCallback) _music_playback_manager_update_metadata_gst_discoverer_discovered, self, 0);
#line 46 "../src/PlaybackManager.vala"
		_tmp11_ = self->priv->discoverer;
#line 46 "../src/PlaybackManager.vala"
		_tmp12_ = self->priv->discoverer;
#line 46 "../src/PlaybackManager.vala"
		g_signal_connect_object (_tmp11_, "finished", (GCallback) _gst_discoverer_stop_gst_discoverer_finished, _tmp12_, 0);
#line 43 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp7_);
#line 2421 "PlaybackManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 43 "../src/PlaybackManager.vala"
		e = _inner_error0_;
#line 43 "../src/PlaybackManager.vala"
		_inner_error0_ = NULL;
#line 48 "../src/PlaybackManager.vala"
		_tmp13_ = e;
#line 48 "../src/PlaybackManager.vala"
		_tmp14_ = _tmp13_->message;
#line 48 "../src/PlaybackManager.vala"
		g_critical ("PlaybackManager.vala:48: Unable to start Gstreamer Discoverer: %s", _tmp14_);
#line 43 "../src/PlaybackManager.vala"
		_g_error_free0 (e);
#line 2441 "PlaybackManager.c"
	}
	__finally0:
#line 43 "../src/PlaybackManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/PlaybackManager.vala"
		_g_object_unref0 (bus);
#line 43 "../src/PlaybackManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/PlaybackManager.vala"
		g_clear_error (&_inner_error0_);
#line 2452 "PlaybackManager.c"
	}
#line 51 "../src/PlaybackManager.vala"
	_tmp15_ = self->priv->_queue_liststore;
#line 51 "../src/PlaybackManager.vala"
	g_signal_connect_object ((GListModel*) _tmp15_, "items-changed", (GCallback) __music_playback_manager___lambda7__g_list_model_items_changed, self, 0);
#line 58 "../src/PlaybackManager.vala"
	g_signal_connect_object ((GObject*) self, "notify::current-audio", (GCallback) __music_playback_manager___lambda8__g_object_notify, self, 0);
#line 79 "../src/PlaybackManager.vala"
	_tmp16_ = g_settings_new ("io.elementary.music");
#line 79 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->settings);
#line 79 "../src/PlaybackManager.vala"
	self->priv->settings = _tmp16_;
#line 34 "../src/PlaybackManager.vala"
	_g_object_unref0 (bus);
#line 34 "../src/PlaybackManager.vala"
	return obj;
#line 2470 "PlaybackManager.c"
}

static void
music_playback_manager_class_init (MusicPlaybackManagerClass * klass,
                                   gpointer klass_data)
{
#line 6 "../src/PlaybackManager.vala"
	music_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/PlaybackManager.vala"
	g_type_class_adjust_private_offset (klass, &MusicPlaybackManager_private_offset);
#line 6 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playback_manager_get_property;
#line 6 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playback_manager_set_property;
#line 6 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = music_playback_manager_constructor;
#line 6 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = music_playback_manager_finalize;
#line 6 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_AUDIO_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_AUDIO_PROPERTY] = g_param_spec_object ("current-audio", "current-audio", "current-audio", MUSIC_TYPE_AUDIO_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_QUEUE_LISTSTORE_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_QUEUE_LISTSTORE_PROPERTY] = g_param_spec_object ("queue-liststore", "queue-liststore", "queue-liststore", g_list_store_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_PLAYBACK_POSITION_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYBACK_POSITION_PROPERTY] = g_param_spec_int64 ("playback-position", "playback-position", "playback-position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/PlaybackManager.vala"
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_INVALIDS_FOUND_SIGNAL] = g_signal_new ("invalids-found", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 2497 "PlaybackManager.c"
}

static void
music_playback_manager_instance_init (MusicPlaybackManager * self,
                                      gpointer klass)
{
#line 6 "../src/PlaybackManager.vala"
	self->priv = music_playback_manager_get_instance_private (self);
#line 7 "../src/PlaybackManager.vala"
	self->priv->_current_audio = NULL;
#line 19 "../src/PlaybackManager.vala"
	self->priv->progress_timer = (guint) 0;
#line 28 "../src/PlaybackManager.vala"
	self->priv->next_by_eos = FALSE;
#line 30 "../src/PlaybackManager.vala"
	self->priv->direction = MUSIC_PLAYBACK_MANAGER_DIRECTION_NONE;
#line 2514 "PlaybackManager.c"
}

static void
music_playback_manager_finalize (GObject * obj)
{
	MusicPlaybackManager * self;
#line 6 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 7 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_audio);
#line 8 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_queue_liststore);
#line 17 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbin);
#line 18 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->discoverer);
#line 20 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->settings);
#line 6 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (music_playback_manager_parent_class)->finalize (obj);
#line 2535 "PlaybackManager.c"
}

static GType
music_playback_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaybackManager), 0, (GInstanceInitFunc) music_playback_manager_instance_init, NULL };
	GType music_playback_manager_type_id;
	music_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPlaybackManager", &g_define_type_info, 0);
	MusicPlaybackManager_private_offset = g_type_add_instance_private (music_playback_manager_type_id, sizeof (MusicPlaybackManagerPrivate));
	return music_playback_manager_type_id;
}

GType
music_playback_manager_get_type (void)
{
	static volatile gsize music_playback_manager_type_id__once = 0;
	if (g_once_init_enter (&music_playback_manager_type_id__once)) {
		GType music_playback_manager_type_id;
		music_playback_manager_type_id = music_playback_manager_get_type_once ();
		g_once_init_leave (&music_playback_manager_type_id__once, music_playback_manager_type_id);
	}
	return music_playback_manager_type_id__once;
}

static void
_vala_music_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 6 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 6 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_CURRENT_AUDIO_PROPERTY:
#line 6 "../src/PlaybackManager.vala"
		g_value_set_object (value, music_playback_manager_get_current_audio (self));
#line 6 "../src/PlaybackManager.vala"
		break;
#line 6 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_QUEUE_LISTSTORE_PROPERTY:
#line 6 "../src/PlaybackManager.vala"
		g_value_set_object (value, music_playback_manager_get_queue_liststore (self));
#line 6 "../src/PlaybackManager.vala"
		break;
#line 6 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_PLAYBACK_POSITION_PROPERTY:
#line 6 "../src/PlaybackManager.vala"
		g_value_set_int64 (value, music_playback_manager_get_playback_position (self));
#line 6 "../src/PlaybackManager.vala"
		break;
#line 2588 "PlaybackManager.c"
		default:
#line 6 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/PlaybackManager.vala"
		break;
#line 2594 "PlaybackManager.c"
	}
}

static void
_vala_music_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
#line 6 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 6 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_CURRENT_AUDIO_PROPERTY:
#line 6 "../src/PlaybackManager.vala"
		music_playback_manager_set_current_audio (self, g_value_get_object (value));
#line 6 "../src/PlaybackManager.vala"
		break;
#line 6 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_QUEUE_LISTSTORE_PROPERTY:
#line 6 "../src/PlaybackManager.vala"
		music_playback_manager_set_queue_liststore (self, g_value_get_object (value));
#line 6 "../src/PlaybackManager.vala"
		break;
#line 6 "../src/PlaybackManager.vala"
		case MUSIC_PLAYBACK_MANAGER_PLAYBACK_POSITION_PROPERTY:
#line 6 "../src/PlaybackManager.vala"
		music_playback_manager_set_playback_position (self, g_value_get_int64 (value));
#line 6 "../src/PlaybackManager.vala"
		break;
#line 2626 "PlaybackManager.c"
		default:
#line 6 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/PlaybackManager.vala"
		break;
#line 2632 "PlaybackManager.c"
	}
}

